;**********************************************************************
display_1bit ; 20 LEDs
;
;  ++++++++ +++++++-------- 
;                    +++--- 
;  11111111 11111111 1111xxxx
;
;**********************************************************************

    movwf        speed              ;w has the speed/delay

; +++------------------------ RGB 1
; |||+++--------------------- RGB 2
; ||||||++ +----------------- RGB 3
; |||||||| |+++-------------- Fire
; |||||||| ||||++++ +++------ Running lights
; |||||||| |||||||| |||+----- IR
; |||||||| |||||||| ||||++++- Delay
; AAABBBCC CDDDEEEE EEEFGGGG


    clrf         A4_A1_reg        ; 1st RGB Red
    btfsc        in0,7
    comf         A4_A1_reg,f 

    clrf         A4_A2_reg        ; 1st RGB Green
    btfsc        in0,6
    comf         A4_A2_reg,f

    clrf         A4_A0_reg        ; 1st RGB Blue
    btfsc        in0,5
    comf         A4_A0_reg,f

    clrf         A1_A5_reg        ; 2nd RGB Red
    btfsc        in0,4
    comf         A1_A5_reg,f

    clrf         A1_A2_reg        ; 2nd RGB Green
    btfsc        in0,3
    comf         A1_A2_reg,f

    clrf         A1_A4_reg        ; 2nd RGB Blue
    btfsc        in0,2
    comf         A1_A4_reg,f
 
    clrf         A0_A1_reg        ; 3rd RGB Red
    btfsc        in0,1
    comf         A0_A1_reg,f

    clrf         A0_A2_reg        ; 3rd RGB Green
    btfsc        in0,0
    comf         A0_A2_reg,f

    clrf         A0_A4_reg        ; 3rd RGB Blue
    btfsc        in1,7
    comf         A0_A4_reg,f
 


    clrf         A0_A5_reg        ; Fire Top
    btfsc        in1,6
    comf         A0_A5_reg,f

    clrf         A5_A2_reg        ; Fire Center
    btfsc        in1,5
    comf         A5_A2_reg,f

    clrf         A2_A5_reg        ; Fire Bottom
    btfsc        in1,4
    comf         A2_A5_reg,f



    clrf         A5_A0_reg        ; Running Top Back
    btfsc        in1,3
    comf         A5_A0_reg,f

    clrf         A1_A0_reg        ; Running Top Center
    btfsc        in1,2
    comf         A1_A0_reg,f

    clrf         A5_A4_reg        ; Running Top Front
    btfsc        in1,1
    comf         A5_A4_reg,f

    clrf         A2_A4_reg        ; Running Front
    btfsc        in1,0
    comf         A2_A4_reg,f

    clrf         A4_A5_reg        ; Running Bottom Front
    btfsc        in2,7
    comf         A4_A5_reg,f

    clrf         A5_A1_reg        ; Running Bottom Center
    btfsc        in2,6
    comf         A5_A1_reg,f

    clrf         A2_A1_reg        ; Running Bottom Back
    btfsc        in2,5
    comf         A2_A1_reg,f


    clrf         A2_A0_reg        ; IR
    btfsc        in2,4
    comf         A2_A0_reg,f
 
    movf         speed,w
    call         strobe_delay

    return

