;**********************************************************************
display_pattern_id
;**********************************************************************

    var          tens
    var          ones
    var          dpif_count ; ones

;   clear the display
;   clear all the inxx vars (32 of themn)
#ifdef __16F1938
    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H
#else
    movlw        in0
    movwf        FSR
    bcf          STATUS,IRP
#endif

    movlw        0x20
    movwf        dpif_count

dpid_loop1
    clrf         INDF0
#ifdef __16F1938
    incf         FSR0L,f
#else
    incf         FSR,f
#endif
    decfsz       dpif_count,f
    goto         dpid_loop1


    clrf         tens
    incf         pattern,w      ; W = pattern + 1
    movwf        ones

;
; split pattern into tens and ones digits.
;
dpid_loop2
    movlw        0x0a           ; less then 10?
    subwf        ones,w
    btfss        STATUS,C
    goto         dpid2
    
    movlw        0x0a 
    subwf        ones,f
    incf         tens,f
    goto         dpid_loop2
;
;   add 10 to ones and tens for digit placement in char table
dpid2
    movlw        0x10
    addwf        ones,f
    addwf        tens,f  

    btfss        demo_mode,0
    goto         dpid3
;
;   print out "D" for demo
;
#ifdef __16F1938
    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H
#else
    movlw        in0
    movwf        FSR
    bcf          STATUS,IRP
#endif
    movlw        0x24  ; (D - 0x20)
    call display_char

dpid3
;
;   print tens digit
;
#ifdef __16F1938
    movlw        LOW in6
    movwf        FSR0L
    movlw        HIGH in6
    movwf        FSR0H
#else
    movlw        in6
    movwf        FSR
    bcf          STATUS,IRP
#endif  
    movfw        tens
    call display_char

;
;   print ones digit
;

#ifdef __16F1938
    incf         FSR0L,f
    clrf         FSR0H
#else
    incf         FSR,f
    bcf          STATUS,IRP
#endif
    movfw        ones 
    call display_char
;
;  display it
;


   movlw        0xff
   call         display_1bit
   movlw        0xff
   call         display_1bit

    return



;**********************************************************************
display_char
;**********************************************************************
;
; FSR = location
; w = char to display
;
; offset_low
; offset_hi
; char_in     b2l_out_hi
; char_words  b2l_in_red
; tentry      b2l_lcount
;

   movwf        char_in

; offset = chartabel
   movlw        LOW chartable     
   movwf        offset_low 
   movlw        HIGH chartable
   movwf        offset_hi

; offset = offset + char_in <<1
   movf         char_in,w
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in,w           
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f   

; char_in << 2 ; if carry offset_hi++         
   bcf          STATUS, C         ; clear carry flag just in case
   rlf          char_in, f
   rlf          char_in, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

; offset = offset + char_in
   movf         char_in,w           ; offset = offset + char_in
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f     

   bcf          INTCON, GIE      ; disable INTs
   call         jump_address
   movwf        char_words

   movf         pclath_save,w
   movwf        PCLATH
   bsf          INTCON, GIE      ; enable INTs

; offset = offset + 1
   movlw        1
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

dc_looper

   bcf          INTCON, GIE      ; disable INTs
   call         jump_address
   movwf        tentry

   movf         pclath_save,w
   movwf        PCLATH
   bsf          INTCON, GIE      ; enable INTs



    movf  tentry, w
    movwf INDF0
    incf  FSR0L,f

; offset = offset + 1
   movlw        1
   addwf        offset_low, f
   btfsc        STATUS,C          ; check carry flag
   incf         offset_hi,f

   decfsz       char_words,f
   goto         dc_looper

   return
