;    list p=12f683,b=4,n=0   ; declare processor, tabs, and lines/page

;**********************************************************************
;   Copyright (C) 2005-2011 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************
;
;   This is a merger of a number of Blinkie programs I created for different
;   www.2DKits.com boards using the newer PIC chips. This code does NOT
;   support the older 12F683, 16F688 and 16F886 2DKits chips.
;
;   The newer chips have enough enhancements and keeping backward compatibility
;   for is not worth the effort. The new chips are better, faster, and cheaper.
;
;   4RBG /w common anode (ufo and clear 5mm) .... Working 01/02/2012
;   4RBG /w common Cathode (milk 5mm) ........... shold be ok
;   6 circle /w bi-color LEDs. .................. Working 01/02/2012
;   6 circle /w mono LEDs. ...................... Working 01/02/2012
;   badge 6 bi-color plus 1 mono, no IR ......... shold be ok
;   badge 7 LED /w mono LEDs, no IR ............. shold be ok
;   19 LED Stick ................................ Working 01/20/2012
;   19 circle /w mono............................ unknown
;   19 circle /w bi-color........................ Working 01/04/2012
;   RGB Stick ................................... unknown
;   3x3 /w mono ................................. unknown
;   3x3 /w bi-color ............................. unknown
;   5x7 matrix .................................. code should be ported over.
;   16x8x2 ...................................... unknown (should be close)
;   12 Circle ................................... unknown (should be close)
;   24 Sphere ................................... unknown (should be close)
;   4x4x4 ....................................... work in progress
;   4x4 ......................................... work in progress
;   gator ....................................... working 8/4/2011
;   dogtag 2RGB ................................. working 8/5/2011
;   dogtag 6 BI ................................. working 8/5/2011
;   Rocket ...................................... work in progress
;   
;   Dwayne Forsyth wrote the original code, Dwayne pulled a number of updates,
;   code cleanup, and patterns from Dave Holle.
;                                                                     
;**********************************************************************
;                                                                     
;    Filename:      generic_2011.asm                                         
;    Date:         2011 (conaints code developed from 2004 onward.                                
;                                                         
;    Author:  Dwayne Forsyth
;    email:   Dwayne@2DKits.com                                         
;    Company: www.2DKits.com
;             502 Rue Orleanais
;             Deer Park, IL 60010    
;
;    Help from: Dave Holle <dav@serve-o-matic.com>                        
;                                                                      
;**********************************************************************

    errorlevel  -302                ; suppress banking messages

; '__CONFIG' directive is used to embed configuration data within .asm file.
; The labels following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.

; this SIM_DEBUG disables the buttons and IR inputs so the code will run the patterns.
#define SIM_DEBUG

;----------------------------------------------------
; Select 1 board config!
;----------------------------------------------------
;#define RGB4                    ; Rom "1"
;#define RGB4_Common_Cathode     ; Rom "2"      ; Working 01/02/2012
;#define BI6                     ; Rom "3"      ; Working 01/02/2012
;#define BI6_MONO                ; Rom "4"      ; Working 01/02/2012
;#define BI6_BADGE               ; Rom "5"
;#define BI6_BADGE_MONO          ; Rom "6"
;#define S19                     ; Rom "7"      ; Working 01/02/2012
;#define C19                     ; Rom "8"      ; Working 01/04/2012
;#define C19_MONO                ; Rom "9"
; 5x7 Mono                       ; Rom "0"
; 5x7                            ; Rom "10"
;#define D10
;#define M3X3                    ; Rom "E"
;#define M3X3_MONO               ; Rom "F"
;#define SRGB                    ; Rom "G"
;#define SRGB_Common_Cathode     ; Rom "H"
;#define M8X16                   ; Rom "J"
;#define C12                     ; Rom "M"
;#define C12_MONO                ; Rom "L"
;#define C12_SINGLE              ; Rom "K"
;#define C12_SINGLE_MONO         ; Rom "P"
#define GATOR                   ; Rom "Q"      ; Working 08/02/2011
;#define BI6_DOGTAG              ; Rom "R"      ; Working 08/02/2011
;#define BI6_DOGTAG_MONO         ; Rom "S"      ; Working 08/02/2011
;#define RGB2_DOGTAG             ; Rom "T"      ; Working 08/02/2011
;#define RGB_4x4x4               ; Rom ?
;#define RGB_4x4                 ; Rom ?
;#define ROCKET                  ; Rom ?        ; Proto Working 08/02/2011
;#define BADGE_G2                  ; Rom ?      ; Proto /w 3 patterns 03/01/2012
;----------------------------------------------------

;*********************************
; 4RBG /w common anode (ufo and clear 5mm)
;*********************************

#ifdef RGB4
#define PATTERN1
#define PATTERN2
#define PATTERN3
#define PATTERN4
#define PATTERN20
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x36
#endif

;*********************************
; 4RBG /w common Cathode (milk 5mm and 10mm)
;*********************************

#ifdef RGB4_Common_Cathode
#define RGB4
#define Common_Cathode
#define PATTERN1
#define PATTERN2
#define PATTERN3
#define PATTERN4
#define PATTERN20
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x36
#endif

;*********************************
; D10 12 LEDs.
;*********************************

#ifdef D10
#define BIN2LED
#define PATTERN1
#define PATTERN3
#define FLIPBYTE
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_I
#define DISPLAY_2BIT_C
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x0A     ; not sure
#endif

;*********************************
; 6 BI /w bi-color LEDs.
;*********************************

#ifdef BI6
#define BIN2LED
#define PATTERN1
#define PATTERN3
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3A     
#endif

;*********************************
; 6 BI /w mono LEDs.
;*********************************

#ifdef BI6_MONO
#define BI6
#define MONO
#define FLIPBYTE
#define PATTERN5
#define PATTERN11
#define DISPLAY_1BIT_A
#define DISPLAY_2BIT_A
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'17'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3A 
#endif

;*********************************
; badge 6 bi-color plus 1 mono LEDs.
;*********************************

#ifdef BI6_BADGE
#define BI6
#define BIN2LED
#define PATTERN10
#define PATTERN3
#define BADGE
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3A 
#endif

;*********************************
; badge 6 mono LEDs.
;*********************************

#ifdef BI6_BADGE_MONO
#define BI6
#define MONO
#define BADGE
#define PATTERN5
#define PATTERN11
#define FLIPBYTE
#define DISPLAY_1BIT_A
#define DISPLAY_2BIT_A
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'19'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3A 
#endif

;#define DREW  ; special pattern in EEProm for Drew

;*********************************
; 19 LED Stick
;*********************************

#ifdef S19
#define PATTERN6
#define PATTERN7
#define PATTERN8
#define FLIPBYTE
#define DISPLAY_1BIT_D
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=P12F1822
NUM_TAB     equ d'23'   ;highest pattern table number
STROBE_LINES equ 0x05
DELAYTIMER equ 0x3A 
#endif

;*********************************
; 19 Circle bicolor 
;*********************************

#ifdef C19
#define PATTERN9
#define PATTERN12
#define PATTERN13
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_B
#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F1824.inc>       ; processor specific variable definitions
 LIST P=PIC16F1824
NUM_TAB     equ d'25'   ;highest pattern table number
STROBE_LINES equ 0x07
DELAYTIMER equ 0x18
#endif

;*********************************
; 19 Circle mono
;*********************************

#ifdef C19_MONO
#define MONO
#define C19
#define PATTERN9
#define PATTERN12
#define PATTERN14
#define RANDOM
#define BIN2LED
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_B
#define DISPLAY_2BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
 NUM_TAB     equ d'25'   ;highest pattern table number
STROBE_LINES equ 0x07
DELAYTIMER equ 0x18 
#endif

;*********************************
; 3x3 matrix Bi-color
;*********************************

#ifdef M3X3
#define PATTERN6
#define PATTERN19
#define PATTERN21
#define BIN2LED
#define DISPLAY_1BIT_F
#define ENABLE_IR
#define MULTIBUTTON
#define RANDOM
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x05
DELAYTIMER equ 0x2E 
#endif

;*********************************
; 3x3 matrix mono
;*********************************

#ifdef M3X3_MONO
#define M3X3
#define MONO
#define PATTERN6
#define PATTERN19
#define PATTERN21
#define BIN2LED
#define DISPLAY_1BIT_F
#define ENABLE_IR
#define MULTIBUTTON
#define RANDOM
#include    <P12F683.inc>       ; processor specific variable definitions
 LIST P=PIC12F683
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x05
DELAYTIMER equ 0x2E 
#endif

;*********************************
; RGB Stick (new UFO
;*********************************

#ifdef SRGB
#define PATTERN15
#define PATTERN16
#define PATTERN17
#define PATTERN18
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'15'   ;highest pattern table number
STROBE_LINES equ 0x07
DELAYTIMER equ 0x18 
#endif

;*********************************
; RGB Stick
;*********************************

#ifdef SRGB_Common_Cathode
#define SRGB
#define Common_Cathode
#define PATTERN15
#define PATTERN16
#define PATTERN17
#define PATTERN18
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_E
#define ENABLE_IR
#include	<P16F688.inc>       ; processor specific variable definitions
 LIST P=PIC16F688
NUM_TAB     equ d'15'   ;highest pattern table number
STROBE_LINES equ 0x07
DELAYTIMER equ 0x18
#endif

;*********************************
; 8x16 Matrix 
;*********************************

#ifdef M8X16
#define PATTERN12
#define PATTERN22
#define PATTERN24
#define PATTERN25
#define PATTERN26
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DISPLAY_1BIT_G
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F1938.inc>       ; processor specific variable definitions
 LIST P=PIC16F1938
NUM_TAB     equ d'18'   ;highest pattern table number
STROBE_LINES equ 0x10
DELAYTIMER equ 0x0a 
#endif

;*********************************
; 24 LED 3D Sphere Bi-color 
;*********************************

#ifdef C12
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
;#include	<P16F886.inc>       ; old chip
; LIST P=PIC16F886              ; old chip
#include	<P16F1936.inc>       ; processor specific variable definitions
 LIST P=PIC16F1936
FSR       EQU FSR0L
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x06
DELAYTIMER equ 0x14 
#endif

;*********************************
; 24 LED 3D Sphere Mono
;*********************************

#ifdef C12_MONO
#define C12
#define MONO
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
;#include	<P16F886.inc>       ; old chip
; LIST P=PIC16F886              ; old chip
#include	<P16F1936.inc>       ; processor specific variable definitions
 LIST P=PIC16F1936
FSR       EQU FSR0L
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x06
DELAYTIMER equ 0x14 
#endif

;*********************************
; 12 Single Bi-color Circle 
;*********************************

#ifdef C12_SINGLE
#define C12
#define SINGLE
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
;#include	<P16F886.inc>       ; old chip
; LIST P=PIC16F886              ; old chip
#include	<P16F1936.inc>       ; processor specific variable definitions
 LIST P=PIC16F1936
FSR       EQU FSR0L
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x06
DELAYTIMER equ 0x14 
#endif

;*********************************
; 12 Single Mono Circle 
;*********************************

#ifdef C12_SINGLE_MONO
#define C12
#define SINGLE
#define MONO
#define PATTERN23
#define PATTERN27
#define BIN2LED
#define RANDOM
#define DEDICATED_BUTTON
#define DEDICATED_BUTTON2
#define DISPLAY_1BIT_H
#define FLIPBYTE
;#define DISPLAY_2BIT_D
#define ENABLE_IR
#include	<P16F1936.inc>       ; processor specific variable definitions
 LIST P=PIC16F1936
FSR       EQU FSR0L
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x06
DELAYTIMER equ 0x14 
#endif


;*********************************
; GATOR
;*********************************

#ifdef GATOR
#define PATTERN6
#define PATTERN28
#define FLIPBYTE
#define DISPLAY_1BIT_GATOR
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=PIC12F1822
NUM_TAB     equ d'08'   ;highest pattern table number
STROBE_LINES equ 0x05
DELAYTIMER equ 0x30 
#endif

;*********************************
; ROCKET
;*********************************

#ifdef ROCKET
#define PATTERN6
#define PATTERN29
#define FLIPBYTE
#define DISPLAY_1BIT_ROCKET
#define ENABLE_IR
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=PIC12F1822
NUM_TAB     equ d'08'   ;highest pattern table number
STROBE_LINES equ 0x05
DELAYTIMER equ 0x30 
#endif

;*********************************
; 6 bi dogtag 
;*********************************

#ifdef BI6_DOGTAG
#define BIN2LED
#define PATTERN1
#define PATTERN3
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=PIC12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3a 
#endif

;*********************************
; 6 bi dogtag MONO 
;*********************************

#ifdef BI6_DOGTAG_MONO
#define MONO
#define BI6_DOGTAG
#define BIN2LED
#define PATTERN1
#define PATTERN3
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=PIC12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x04
DELAYTIMER equ 0x3a 
#endif

;*********************************
; 2RGB DogTag 
;*********************************

#ifdef RGB2_DOGTAG
#define PATTERN1
#define PATTERN2
#define PATTERN3
#define PATTERN4
#define PATTERN20
#define DISPLAY_1BIT_C
#define DISPLAY_2BIT_C
#define FLIPBYTE
#include    <P12F1822.inc>       ; processor specific variable definitions
 LIST P=PIC12F1822
NUM_TAB     equ d'14'   ;highest pattern table number
STROBE_LINES equ 0x03
DELAYTIMER equ 0x3a 
#endif

;*********************************
; Badge G2 
;*********************************

#ifdef BADGE_G2
#define Common_Cathode
#define PATTERN6
#define PATTERN30
;#define PATTERN17
;#define PATTERN18
#define DISPLAY_1BIT_BADGE_G2
#include	<P16F1824.inc>       ; processor specific variable definitions
 LIST P=PIC16F1824
NUM_TAB     equ d'2'   ;highest pattern table number
STROBE_LINES equ 0x06
DELAYTIMER equ 0x18
#endif



; '__CONFIG' directive is used to embed configuration data within .asm file.
; The labels following the directive are located in the respective .inc file.
; See respective data sheet for additional information on configuration word.

#ifdef __12F1822
    __CONFIG    _CONFIG1, _CLKOUTEN_OFF & _FCMEN_ON & _IESO_OFF & _BOREN_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDTE_OFF  & _FOSC_INTOSC
    __CONFIG    _CONFIG2, _WRT_OFF & _BORV_19 & _PLLEN_OFF & _STVREN_ON & _LVP_OFF
#else
#ifdef __16F1936
    __CONFIG    _CONFIG1, _CLKOUTEN_OFF & _FCMEN_ON & _IESO_OFF & _BOREN_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDTE_OFF  & _FOSC_INTOSC
    __CONFIG    _CONFIG2, _WRT_OFF & _BORV_19 & _PLLEN_OFF & _STVREN_ON & _LVP_ON
#else
#ifdef __16F1938
    __CONFIG    _CONFIG1, _CLKOUTEN_OFF & _FCMEN_ON & _IESO_OFF & _BOREN_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDTE_OFF  & _FOSC_INTOSC
    __CONFIG    _CONFIG2, _WRT_OFF & _BORV_19 & _PLLEN_OFF & _STVREN_ON & _LVP_ON
#else
#ifdef __16F1824
    __CONFIG    _CONFIG1, _CLKOUTEN_OFF & _FCMEN_ON & _IESO_OFF & _BOREN_OFF & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDTE_OFF  & _FOSC_INTOSC
    __CONFIG    _CONFIG2, _WRT_OFF & _BORV_19 & _PLLEN_OFF & _STVREN_ON & _LVP_OFF
#else
    error 'Non Supported PIC chip'
#endif
#endif
#endif
#endif



;**********************************************************************
; Macros
;**********************************************************************

mem = 20
mem2 = 0x7F
mem3 = 0xa0
#include macros.asm


;             ++-------- A7 A6  unimplemented (0)
;             || +------ A4     IR LED output (0)
;             || |+----- A3     detector/button input (1)
;             || ||
;           b'00101111'     ;set LED matrix pins to input (tri-stated)
;               |  ||| 
;               +--+++-- LED matrix on A5 A2 A1 A0 (1)

;**********************************************************************
    ORG     0x000           ; processor reset vector
;**********************************************************************
; Current hack to debug 4x4x4 DDF
#ifdef RGB_4x4x4
    goto        main3            ; go to beginning of program
#else
    goto        main            ; go to beginning of program
#endif

;**********************************************************************
    ORG     0x004           ; interrupt vector location
;**********************************************************************

    var nextf                    ; flags for timing loops
;                                  bit 0 is one display cycle (890 usec)
;                                  bit 1 is about 1 minute
    var dcycle                   ; stobe counter [0-3]
    var count1                   ; lower bit counter
    var count2                   ; higher bit counter.


here
#ifndef __12F1822
    PAGESEL    here ; DDF
#endif
;
;   set tick interupt to 889ms for IR RC5 protocal 1/2 digit.
;   an Interupt every 889us /w 8mhz internal osc
;

#define  TICK_VALUE   D'35'

    BANKSEL TMR0
    movlw       TICK_VALUE
    movwf       TMR0                       
;
;   increment the stobe and duration counters
;

    incf     dcycle,f

    movlw    STROBE_LINES
    subwf    dcycle,w
    btfsc    STATUS,C
    clrf     dcycle

    bsf      nextf,0

    incfsz      count1,f
    goto        skip1

    incfsz      count2,f
    goto        skip1

    bsf         nextf,1

skip1

    movf        scount,w                    ; F22
    addlw       0                           ; F23
    btfsc       STATUS,Z                    ; F24
    goto        send_nothing                ; F25

    btfss       tx_1,0                      ; F26
    goto        send_zero                   ; F27

;--------------------------------------------------------------------------------------
send_one  ; we are slaming the 36K IR siginal, its like a busy wait!
;--------------------------------------------------------------------------------------
    var repeat
#ifdef GATOR
    BANKSEL TRISA
    movlw   b'00011010'      ;set A4 & A5 led to output
    movwf   TRISA
    BANKSEL 0
#define IRBIT 4
#define IRPORT PORTA
#else
#ifdef S19
    banksel TRISA
    movlw   b'00011010'      ;set A0 & A5 led to output
    movwf   TRISA
    banksel PORTA
#define IRBIT 0
#define IRPORT PORTA
#else
#ifdef C12
    BANKSEL TRISB
    movlw   b'11011011'      ;set B2 & B5 led to output
    movwf   TRISB
    BANKSEL PORTB
#define IRBIT 2              
#define IRPORT PORTB
#else
#ifdef M8X16
#define IRBIT 1              
#define IRPORT PORTC
#else
#ifdef M3X3
    setbank1
    movlw   b'00111001'      ;set A1 & A2 led to output
    movwf   TRISA
    setbank0
#define IRBIT 1
#define IRPORT PORTA
#else
#ifdef SRGB
#define IRBIT 1
#define IRPORT PORTA
#else
#define IRBIT 4
#define IRPORT PORTA
#endif
#endif
#endif
#endif
#endif
#endif

    clrf        IRPORT
    bsf         IRPORT,IRBIT                     ; A01

    call        get_next_tx_bit             ; 2 + 11 cycles  A04-A16
;    mult_nop d'9' ; A17-A25
    movlw       01h
    call        qdelay           ; 6 + (1 * 3) = 9 ; A17-A25
    nop

    movlw           0x1E                    ; C26  (23)
    movwf           repeat                  ; C27
repeat_loop
    bcf         IRPORT,IRBIT                         ; D01

;    mult_nop d'26' ; D02-D27
    movlw       07h
    call        qdelay           ; 6 + (7 * 3) = 27 ; D02-D27

    bsf         IRPORT,IRBIT                         ; E01  (27)

;    mult_nop d'23' ; E02-E24
    movlw       06h              ; 6+(6 * 3) = 22 ; E02-E24
    call qdelay

    decfsz      repeat,f                    ; E25      (24)
    goto        repeat_loop                    ; E26/E27

    bcf         IRPORT,IRBIT
    goto        exit_tx

;--------------------------------------------------------------------------------------
send_zero  ; we are going to release all the CPU time to the main line for display.
;--------------------------------------------------------------------------------------

    call        get_next_tx_bit             ; 2 + 11 cycles  A04-A16
    goto        drive_main_leds

;--------------------------------------------------------------------------------------
send_nothing ; Drive the main LEDs.
;--------------------------------------------------------------------------------------


    call        read_ir_in
#ifdef DEDICATED_BUTTON
    call        read_button_in
#endif
;   goto        drive_main_leds   

;--------------------------------------------------------------------------------------
drive_main_leds ; Drive the main LEDs.
;--------------------------------------------------------------------------------------
	var fcount

#include <LED_storage.asm>

#ifndef M8X16
    var_all_bank Ax_dir
#endif
#ifdef C19
    var_all_bank Cx_dir
#endif
#ifdef BADGE_G2
    var_all_bank Cx_dir
#endif
#ifdef SRGB
    var_all_bank Cx_dir
#endif
#ifdef C12
    var_all_bank Bx_dir
#endif

;
; This is the number of times the display logic should cycle before exiting. It's been hand timed from the
; start of the interupt to the end to be around 800usec. This leaves 90 usec for the main loop.
; The 19 stick has an extra display line strobe cycle.
;

    movlw   DELAYTIMER
    movwf   fcount

#ifdef C19
    movlw   b'00101000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
    clrf    Cx_dir          ;set LED matrix pins to input (tri-stated)
#else
#ifdef D10
    movlw   b'00101000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
#else
#ifdef SRGB
    movlw   b'00111000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
    clrf    Cx_dir          ;set LED matrix pins to input (tri-stated)
#else
#ifdef C12
    clrf    Ax_dir     ;set LED matrix pins to input (tri-stated)
    clrf    Bx_dir
#else
#ifdef BADGE_G2
    movlw   b'11111000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir    ; A0,A1,A2
    movwf   Cx_dir    ; C0,C1,C2
#else
#ifndef M8X16
    movlw   b'00001000'     ;set LED matrix pins to input (tri-stated)
    movwf   Ax_dir
#endif ; not M8X16
#endif ; BADGE_G2
#endif ; C12
#endif ; SRGB
#endif ; D10
#endif ; C19


    call    get_state_tbl_hi_address
    call    get_state_tbl_low_address
    call    go_state_table
    call    set_max_state

;   turn off the LEDs DDF
;    clrf         PORTA
;    clrf         PORTB

    movf         dcycle,w         ; testing for 0
    btfsc        STATUS,Z
    call         display_cycle0

    movlw        0x01             ; testing for 1
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle1

    movlw        0x02             ; testing for 2
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle2

#ifndef RGB2_DOGTAG
    movlw        0x03             ; testing for 3
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle3

#ifndef BI6
#ifndef RGB4
#ifndef BI6_DOGTAG
    movlw        0x04             ; testing for 4
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle4

#ifndef GATOR
#ifndef ROCKET
#ifndef S19
#ifndef M3X3
    movlw        0x05             ; testing for 5
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle5
#ifndef BADGE_G2
#ifndef C12
    movlw        0x06             ; testing for 6
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle6
#ifndef C19
#ifndef SRGB
    movlw        0x07             ; testing for 7
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle7

    movlw        0x08             ; testing for 8
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle8

    movlw        0x09             ; testing for 9
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle9

    movlw        0x0a             ; testing for 10
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle10

    movlw        0x0b             ; testing for 11
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle11

    movlw        0x0c             ; testing for 12
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle12

    movlw        0x0d             ; testing for 13
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle13

    movlw        0x0e             ; testing for 14
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle14

    movlw        0x0f             ; testing for 15
    subwf        dcycle,w
    btfsc        STATUS,Z
    call         display_cycle15
#endif ; SRGB
#endif ; C19
#endif ; C12
#endif ; BADGE_G2
#endif ; M3X3
#endif ; S19
#endif ; GATOR
#endif ; ROCKET
#endif ; BI6_DOGTAG
#endif ; RGB4
#endif ; BI6
#endif ; RGB2_DOGTAG
;--------------------------------------------------------------------------------------
exit_tx
;--------------------------------------------------------------------------------------



    clrf       PORTA
#ifndef __12F1822
#ifndef __16F1824
    clrf       PORTB
#endif
#endif
#ifdef __16F1824
    clrf       PORTC
#endif

;   clear timer0 interupt

    bcf         INTCON,TMR0IF

; restore state, return form interupt

exit_int
    retfie                  ; return from interrupt


#ifdef RGB_4x4x4
;
; M A I N 2
;
;**********************************************************************
main2
;**********************************************************************

    var fred
    clrf        PORTA
    clrf        TMR0 
    clrf        pattern
    clrf        scount
    clrf        toggle
    clrf        address
    clrf        command
    clrf        IR_lhalf
    clrf        instate
    clrf        max_instate
    clrf        IR_in_good
    clrf        dcycle
    clrf        count1
    clrf        count2
    clrf        button
#ifdef PATTERN2
    clrf         delay1
    clrf         fad
    clrf         color
#endif

   BANKSEL  OSCCON

;            +------------- PLL enable (1)
;            |++++--------- 8MHZ/32MHZ (1110)   IRCF<3:0>
;            ||||| ++------ Internal OSC (1x)
;            ||||| ||
   movlw   b'01110000'     ;switch to 32 MHz clock, PLL is set on in config1, bit 7 ignored.
   movwf  OSCCON


    BANKSEL ANSELA
    clrf    ANSELA           ;set pins to digital
    BANKSEL LATA
    clrf    LATA

#ifndef __12F1822
    BANKSEL LATB
    clrf    LATB
    BANKSEL ANSELB
    clrf    ANSELB
#endif

#ifdef  __16F1824
    BANKSEL LATC
    clrf    LATC
#endif

   BANKSEL OPTION_REG
; set up TMR0 & pullups
;             +---------- disable pullups (1)
;             |+--------- interrupt edge select (don't care)
;             ||+-------- TMR0 source = internal clock (0) TMR0CS
;             |||+------- TMR0 source edge select (don't care) TMR0SE
;             ||||+------ assign prescaler to TMR0 (0) PSA
;             |||||+++--- prescaler set to 8X (010) PS
;             |||||||| 
    movlw   b'10000010'
    movwf   OPTION_REG

;  E1 - IR/Button
;  C2 - Button2
;  C1 - IR out
;  C3/C4 - I2C
;  C0,C5,C6,C7 - strobe select output
   BANKSEL TRISC
    movlw   b'00011100'
    movwf   TRISC   ; C7,C6,C5,C1,C0 output
    clrf    TRISA   ; all A output
    clrf    TRISB   ; all B output
    movlw   b'00001000'
    movwf   TRISE   ; E3 input

    BANKSEL     button 
    clrf        button

    movlw       0x1D
    movwf       random


;   enable timer0 interupt
    BANKSEL INTCON
    bsf     INTCON,TMR0IE
    bsf     INTCON,GIE

;  flash all LEDs on     This kills some time, allowing us to sample the button and IR-Rx

loop_main2

    movlw        LOW in0        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H

    movlw   0x20
    movwf   fcount1

    incf    fred,f
    movfw   fred
loop_set_ona
    movwf   INDF0

    incf         FSR0L,f
    decfsz  fcount1,f
    goto    loop_set_ona

    movlw   0xff            ; allways flash once
    call    display_1bit
    movlw   0xff
    call    display_1bit

    goto    loop_main2

;
; M A I N
;
;**********************************************************************
main3
;**********************************************************************

    clrf        PORTA
    clrf        TMR0 
    clrf        pattern
    clrf        scount
    clrf        toggle
    clrf        address
    clrf        command
    clrf        IR_lhalf
    clrf        instate
    clrf        max_instate
    clrf        IR_in_good
    clrf        dcycle
    clrf        count1
    clrf        count2
    clrf        button
#ifdef PATTERN2
    clrf         delay1
    clrf         fad
    clrf         color
#endif

    movlw        0x00
    movwf        fred

   BANKSEL  OSCCON

;            +------------- PLL enable (1)
;            |++++--------- 8MHZ/32MHZ (1110)   IRCF<3:0>
;            ||||| ++------ Internal OSC (1x)
;            ||||| ||
   movlw   b'11110000'     ;switch to 32 MHz clock, if PLL is set on in config1, bit 7 ignored.
;   movlw   b'01111000'     ;switch to 16 MHz clock
;   movlw   b'01110000'     ;switch to 8 MHz clock, if PLL is set on in config1 must be OFF
   movwf  OSCCON


    BANKSEL ANSELA
    clrf    ANSELA           ;set pins to digital
    BANKSEL LATA
    clrf    LATA

    BANKSEL LATB
    clrf    LATB
    BANKSEL ANSELB
    clrf    ANSELB

    BANKSEL LATC
    clrf    LATC

   BANKSEL OPTION_REG
; set up TMR0 & pullups
;             +---------- disable pullups (1)
;             |+--------- interrupt edge select (don't care)
;             ||+-------- TMR0 source = internal clock (0) TMR0CS
;             |||+------- TMR0 source edge select (don't care) TMR0SE
;             ||||+------ assign prescaler to TMR0 (0) PSA
;             |||||+++--- prescaler set to 8X (010) PS
;             |||||||| 
    movlw   b'10000010'
    movwf   OPTION_REG

;  E1 - IR/Button
;  C2 - Button2
;  C1 - IR out
;  C3/C4 - I2C
;  C0,C5,C6,C7 - strobe select output
   BANKSEL TRISC
    movlw   b'00011100'
    movwf   TRISC   ; C7,C6,C5,C1,C0 output
    clrf    TRISA   ; all A output
    clrf    TRISB   ; all B output
    movlw   b'00001000'
    movwf   TRISE   ; E3 input

    BANKSEL     button 
    clrf        button

    movlw       0x1D
    movwf       random


;   enable timer0 interupt
    BANKSEL INTCON
    bsf     INTCON,TMR0IE
    bsf     INTCON,GIE

;  flash all Red LEDs on


; Set in0-inf to "0x00" green off.
    movlw        LOW in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H

    movlw   0x10
    movwf   fcount1
    movlw   0x00
loop_main3_green_off

    MOVWI   INDF0++

    decfsz  fcount1,f
    goto    loop_main3_green_off
    
; Set in10-in1f to "0xFF" red on.
    movlw        LOW in10
    movwf        FSR0L
    movlw        HIGH in1f
    movwf        FSR0H

    movlw   0x10
    movwf   fcount1

    movlw   0xFF
loop_main3_red

    MOVWI   INDF0++

    decfsz  fcount1,f
    goto    loop_main3_red
    
;   display all red
    movlw   0xff       
    call    display_1bit
    movlw   0xff       
    call    display_1bit

loop_main3

;   Shift is all left
    call shift_left

; Load the new row of red.
    movlw        LOW in1f
    movwf        FSR0L
    movlw        HIGH in1f
    movwf        FSR0H

    incf    fred,f
    movfw   fred
;    movlw  0x00
    MOVWI INDF0++

; Load the new row of green.
    movlw        LOW inf    
    movwf        FSR0L
    movlw        HIGH inf
    movwf        FSR0H

;    incf    fred,f
    movfw   fred
;    movlw  0x00
    MOVWI INDF0++


    movlw   0x7f       
    call    display_1bit

    goto    loop_main3


#endif ; RGB_4x4x4


#define DEBOUNCE 0x10



#ifdef RGB4
#include <strobe_rgb4.asm>
#else
#ifdef D10
#include <strobe_d10.asm>
#else
#ifdef BI6
;    swapf     w_temp,f  # should not be here
#include <strobe_bi6.asm>
#else
#ifdef GATOR
#include <strobe_gator.asm>
#else
#ifdef ROCKET
#include <strobe_rocket.asm>
#else
#ifdef S19
#include <strobe_s19.asm>
#else
#ifdef C19
#include <strobe_c19.asm>
#else
#ifdef M3X3
#include <strobe_m3x3.asm>
#else
#ifdef SRGB
#include <strobe_srgb.asm>
#else
#ifdef M8X16
#include <strobe_m8x16_g2.asm>
#else
#ifdef C12
#include <strobe_c12.asm>
#else
#ifdef BI6_DOGTAG
#include <strobe_bi6_dogtag.asm>
#else
#ifdef RGB2_DOGTAG
#include <strobe_rgb2.asm>
#else
#ifdef BADGE_G2
#include <strobe_badge_g2.asm>
#else
    error "unknown board strobe type"
#endif ; BADGE_G2
#endif ; RGB2_DOGTAG
#endif ; BI6_DOGTAG
#endif ; C12
#endif ; M8X16
#endif ; SRGB
#endif ; M3X3
#endif ; S19
#endif ; C19
#endif ; ROCKET
#endif ; GATOR
#endif ; BI6
#endif ; D10
#endif ; RGB4


;**************************************************************************************
;
; State Machine
;
;**************************************************************************************

    var instate
    var max_instate
    var IR_in
    var command
    var address
    var toggle
    var IR_lhalf
    var button
#ifdef M3X3
    var button0
    var button1
    var button2
    var button3
    var button4
#endif
    var tx_1
    var pindex2
    var IR_in_good
    var butcount

;--------------------------------------------------------------------------------------
get_state_tbl_hi_address ; 17 cycles
;--------------------------------------------------------------------------------------
    var tbl2_hi

    bcf          STATUS,0        ; clear carry flag           ; 1
    rlf          instate,w       ; entry = table * 2          ; 2
    movwf        pindex2                                      ; 3
    call         table_lookup2                                ; 14 (9+2)
    movwf        tbl2_hi                                      ; 15
    return                                                    ; 16/17

;--------------------------------------------------------------------------------------
get_state_tbl_low_address  ; 18 cycles
;--------------------------------------------------------------------------------------
    var tbl2_low

    bcf          STATUS,0      ; clear carry flag (just in case)  ; 1
    rlf          instate,w     ; entry = table * 2 + 1            ; 2
    addlw        1                                                ; 3
    movwf        pindex2                                          ; 4
    call         table_lookup2                                    ; 15 (9+2)
    movwf        tbl2_low                                         ; 16
    return                                                        ; 17/18

;**********************************************************************
table_lookup2  ; 9 cycles
;**********************************************************************
    movlw        HIGH state_jump_table                 ; 1
    movwf        PCLATH                                ; 2
    movf         pindex2,w                             ; 3
    addlw        LOW state_jump_table                  ; 4
    btfsc        STATUS,0     ; check carry flag       ; 5
    incf         PCLATH,f                              ; 6
    movwf        PCL                                   ; 7 + 2

;**********************************************************************
go_state_table  ; 18 cycles
;**********************************************************************

    movf         tbl2_hi,w    ; 1
    movwf        PCLATH       ; 2
    movf         tbl2_low,w   ; 3
    movwf        PCL          ; 4

;**********************************************************************
state_jump_table
;**********************************************************************
    make_state_jump_table d'31'

    state_tbl 0, 6, 1, 0
    state_tbl 1, 0, 2, -1
    state_tbl 2, 0, 3, -1
    state_tbl 3, 4, 3, -1
    state_tbl 4, 0, 5, -1
    state_tbl 5, 7, 0, -1

Lstate6
 
     btfsc        IR_in,0
     goto         Lstate6a

     movlw        0
     addwf        butcount,w
     btfsc        STATUS,Z
     goto         Lstate6b

     decfsz       butcount,f
     goto         Lcontinue
     
Lstate6b

#ifndef MULTIBUTTON
     bsf  button,0                          
#endif
     goto         Lcontinue
     
Lstate6a
     clrf        instate
     goto         Lcontinue       

    state2_tbl 7, toggle, 0
    state2_tbl 9, address, 4    
    state2_tbl d'11', address, 3    
    state2_tbl d'13', address, 2    
    state2_tbl d'15', address, 1    
    state2_tbl d'17', address, 0    
    state2_tbl d'19', command, 5    
    state2_tbl d'21', command, 4    
    state2_tbl d'23', command, 3    
    state2_tbl d'25', command, 2    
    state2_tbl d'27', command, 1    
    state2_tbl d'29', command, 0    

Lstate31
    clrf        instate
    bsf         IR_in_good,0    

Lcontinue
    return

;--------------------------------------------------------------------------------------
read_button_in   ; 5 cycles
;--------------------------------------------------------------------------------------
; Portability : hardcoded button port
;

#ifndef ENABLE_IR
    clrf        button
#endif

#ifndef SIM_DEBUG
#ifdef D10
    btfss       PORTA,3          ; 2 
    bsf         button,0         ; 3
    btfss       PORTA,5          ; 2
    bsf         button,1         ; 3
#else
#ifdef M8X16
    bcf         button,1         ; 1
    btfss       PORTC,2          ; 2
    bsf         button,1         ; 3           
#else ; M8X16
#ifndef MULTIBUTTON
    bcf         button,0         ; 1
    bcf         button,1         ; 1
#ifdef DEDICATED_BUTTON2
#ifdef SRGB
    btfss       PORTA,5          ; 2 ; stick has 2 buttons.
    bsf         button,1         ; 3
    btfss       PORTA,4          ; 2
    bsf         button,0         ; 3
#else ; SRGB
    btfss       PORTC,5          ; 2 ; Dual 12C has 2 buttons.
    bsf         button,0         ; 3
    btfss       PORTC,7          ; 2
    bsf         button,1         ; 3
#endif ; SRGB
#else ; DEDICATED_BUTTON2
    btfss       PORTA,5          ; 2
    bsf         button,0         ; 3
#endif ; not DEDICATED_BUTTON2
#endif ; not MULTIBUTTON
#endif ; not M8x16
#endif ; D10
#endif ; not SIM_DEBUG
    return                        

;--------------------------------------------------------------------------------------
read_ir_in   ; 5 cycles
;--------------------------------------------------------------------------------------
    bcf         IR_in,0         ; 1
#ifndef SIM_DEBUG
#ifdef C12
    btfsc       PORTC,6         ; 2
#else
#ifdef M8X16
    btfsc       PORTE,3         ; 2
#else
    btfsc       PORTA,3         ; 2
#endif
#endif
#endif

    bsf         IR_in,0         ; 3

;    movf        tx_1,w   ; loopback for testing HACK!!        ;1
;    xorlw       0x01       ; loopback for testing HACK!!      ;2
;    movwf       IR_in      ; loopback for testing HACK!!      ;3
    return                                                     ; 4/5

;--------------------------------------------------------------------------------------
set_max_state   ; 5-7 cycles
;--------------------------------------------------------------------------------------
    movf         max_instate,w  
    subwf        instate,w       
    btfss        STATUS,C        
    goto         smi_l1          
    movf         instate,w       
    movwf        max_instate     
smi_l1
    return                       

;--------------------------------------------------------------------------------------
get_next_tx_bit   ; 11 cycles
;--------------------------------------------------------------------------------------

    bcf         tx_1,0                                 ;1
    decf        scount,f                               ;2
    bcf         STATUS, C   ; clear carry bit          ;3
    rrf         out3,f                                 ;4
    rrf         out2,f                                 ;5
    rrf         out1,f                                 ;6
    rrf         out0,f                                 ;7
    btfsc       STATUS, C                              ;8
    bsf         tx_1,0                                 ;9
 
;    movf        tx_1,w   ; loopback for testing HACK!!
;    xorlw       0x01       ; loopback for testing HACK!!
;    movwf       tx_1      ; loopback for testing HACK!!
;    mult_nop d'6'         ; for debuging
  
    return                                             ;10/11

;**********************************************************************
qdelay
;**********************************************************************
    var qcount

    movwf       qcount
delay_loop2
    decfsz      qcount,1
    goto        delay_loop2
    return
;**********************************************************************
rf_command_out
;**********************************************************************

    var out_address
    var out_command
    var out_toggle
    var out_pattern
    var out0
    var out1
    var out2
    var out3
    var scount

    clrf        out1
    clrf        out2
    clrf        out3

;   start flag
    movlw       B'10100000'
    movwf       out0


;   toggle bit
    comf        out_toggle,f                ; toggle the toggle flag
    btfss       out_toggle,0
    bsf         out1,0
    btfsc       out_toggle,0
    bsf         out1,1

;   address bits
    btfss       out_address,4
    bsf         out1,2
    btfsc       out_address,4
    bsf         out1,3

    btfss       out_address,3
    bsf         out1,4
    btfsc       out_address,3
    bsf         out1,5

    btfss       out_address,2
    bsf         out1,6
    btfsc       out_address,2
    bsf         out1,7

    btfss       out_address,1
    bsf         out2,0
    btfsc       out_address,1
    bsf         out2,1

    btfss       out_address,0
    bsf         out2,2
    btfsc       out_address,0
    bsf         out2,3

;   command bits
    btfss       out_command,5
    bsf         out2,4
    btfsc       out_command,5
    bsf         out2,5

    btfss       out_command,4
    bsf         out2,6
    btfsc       out_command,4
    bsf         out2,7

    btfss       out_command,3
    bsf         out3,0
    btfsc       out_command,3
    bsf         out3,1

    btfss       out_command,2
    bsf         out3,2
    btfsc       out_command,2
    bsf         out3,3

    btfss       out_command,1
    bsf         out3,4
    btfsc       out_command,1
    bsf         out3,5

    btfss       out_command,0
    bsf         out3,6
    btfsc       out_command,0
    bsf         out3,7

    movlw       0x21
    movwf       scount

    return

#ifdef BIN2LED
;**********************************************************************
bin2led
;**********************************************************************
    var b2l_out_hi
    var b2l_out_low
    var b2l_lcount
    var b2l_in_red
    var b2l_in_green

    clrf        b2l_out_hi
    clrf        b2l_out_low
    movlw       0x08
    movwf        b2l_lcount
b2l_loop
    bcf         STATUS, C
    rrf         b2l_in_green,f
    rlf         b2l_out_low,f
    rlf         b2l_out_hi,f
    rrf         b2l_in_red,f
    rlf         b2l_out_low,f
    rlf         b2l_out_hi,f

    decfsz      b2l_lcount,f
    goto        b2l_loop
    return
#endif
#ifdef FLIPBYTE
;**********************************************************************
flipbyte
;**********************************************************************
     var flip_in
     var flip_out
     var flip_lcount

     movwf       flip_in
     clrf        flip_out
     movlw       0x08
     movwf       flip_lcount
fbyte_loop
     bcf         STATUS, C
     rrf         flip_in,f
     rlf         flip_out,f
 
     decfsz      flip_lcount,f
     goto        fbyte_loop
 
     movfw       flip_out
     return
#endif
                 
;**********************************************************************
delay
;**********************************************************************

    var         delay_count

;   movlw       0ffh
    movwf       delay_count
delay_loop
    nop
    decfsz      delay_count,1
    goto        delay_loop
    return

;**********************************************************************
next_pattern
;**********************************************************************
    incf         pattern,f
    movf         pattern,w
    sublw        NUM_TAB+1  ; max pattern?
    btfsc        STATUS,2   ; z bit check
    clrf         pattern    ; reset to zero
    movfw        pattern
    movwf        out_pattern
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
past_pattern
;**********************************************************************
    decf         pattern,f
    movf         pattern,w
    addlw        1  ; max pattern?
    btfss        STATUS,2   ; z bit check
    goto         past_exit
    movlw        NUM_TAB
    movwf        pattern
    movwf        out_pattern
past_exit
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
set_pattern         ;set pattern from IR
;**********************************************************************
; extra logic because all the different blinkes talk to each other, but
; do not have the same number of patterns. So if blinkie "A" sents a
; pattern 22 to blinkie "B" which only has 10 patterns, Blinkie "B"
; starts to show pattern 2. (22 % 10 a mod function.) But to make
; things fair in blinkie wars, it will transmit pattern 22 to other
; blinkies.
;**********************************************************************

    movfw        command
    movwf        pattern
    movwf        out_pattern
set_loop
    addlw        0xff-NUM_TAB
    btfss        STATUS, C
    goto         set_exit

    movlw        NUM_TAB
    subwf        pattern,f
    movfw        pattern
    goto         set_loop

set_exit
    clrf         pindex
    clrf         pindex1
    return

;**********************************************************************
strobe_delay
;**********************************************************************

    var          strobe_count

    movwf        strobe_count
strobe_delay1
    bcf          nextf,0

strobe_delay2
    btfss        nextf,0
    goto         strobe_delay2

    decfsz       strobe_count,f
    goto         strobe_delay1

    return

#ifdef M8X16
#include display_pattern_id_8x16.asm
#else
;**********************************************************************
display_pattern_id
;**********************************************************************
    incf         pattern,w      ; W = pattern + 1
#ifdef SRGB
    movwf        in1
    clrf         in0
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
#else
#ifdef C12
    call         flipbyte
    movwf        in0
    clrf         in1
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
    movlw        b'01110000'
    btfsc        demo_mode,0
    movwf        in1  
#else  ; everyone else
    movwf        in0
#endif ; C12
#endif ; SRGB

; CDDDEEEE EEEFGGGG
#ifdef ROCKET
    call         flipbyte
    movwf        in1    ; save pattern in in0
    movwf        in2    ; save pattern in in1
; CDDDEEEE EEEFGGGG
; 12345678 12345678
    lslf         in2,f
    lslf         in2,f
    lslf         in2,f    ; shift up 3 bits.
; CDDDEEEE EEEFGGGG
; 12345678 45678---
    bcf          in2,5
    bcf          in2,4    ; clear 2 bits (6&7)
; CDDDEEEE EEEFGGGG
; 12345678 456-----
    lsrf         in1,f
    lsrf         in1,f
    lsrf         in1,f
    lsrf         in1,f    ; shift down 4 bits.
; CDDDEEEE EEEFGGGG
; ----1234 456-----
    bcf          in1,0    ; clear center running light
; CDDDEEEE EEEFGGGG
; ----123- 456-----
    clrf         in0

#endif ; ROCKET

#ifdef GATOR
    call         flipbyte
    movwf        in0
    clrf         in1
    clrf         in2
#endif ; GATOR

#ifdef BI6_DOGTAG
    movwf        b2l_in_red
    clrf         b2l_in_green
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1

    btfsc        demo_mode,0
#ifdef MONO
    bsf          in1,4
#else
    bsf          in1,5
#endif
#endif

#ifdef RGB2_DOGTAG
    call         flipbyte
    movwf        in0
    lslf         flip_out,f
    lslf         flip_out,w
    movwf        in1
#endif

#ifdef S19
    call         flipbyte
    movwf        in0
#endif ; S19

#ifdef BI6
#ifdef MONO
    call         flipbyte
    movwf        in0
#else
#ifdef D10
    call         flipbyte
    movwf        in0
    clrf         in1
#else
    movwf        b2l_in_green
    clrf         b2l_in_red
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1
#endif  ; D10
#endif  ; Mono
#endif  ; BI6

#ifdef M3X3
    movwf        b2l_in_green
    clrf         b2l_in_red
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1
#endif ; M3X3

#ifdef C19
;   outer ring hars the pattern number
    movwf        b2l_in_red
    clrf         b2l_in_green
    call         bin2led
    movf         b2l_out_hi,w
    movwf        in0
    movf         b2l_out_low,w
    movwf        in1

;   center LED turned on
    clrf         in2          
    clrf         in3
    movlw        b'00001100'  
    movwf        in4

;   middle ring on if demo mode
    btfss        demo_mode,0
    goto         skip4

    comf         in3,f
    movlw        b'11111100'  
    movwf        in4
skip4

#endif ; C19

#ifdef GATOR
    clrf        in2

    movlw        b'10000000'
    btfsc        demo_mode,0
    movwf        in2  
#endif ; GATOR

#ifdef RGB2_DOGTAG
    bcf          in0,2
    btfsc        demo_mode,0
    bsf          in0,2
#endif


#ifdef M3X3
    clrf        in2

    movlw        b'11100000'
    btfsc        demo_mode,0
    movwf        in2  
#endif ; M3X3

#ifdef S19
    clrf        in1
    clrf        in2

    movlw        b'11100000'
    btfsc        demo_mode,0
    movwf        in2    
#else
#ifdef BI6
#ifdef MONO
    btfsc        demo_mode,0
    bsf          in0,2  
#else  ; bicolor
    btfsc        demo_mode,0
    bsf          in1,4  
#endif ; end Mono/bicolor
#endif ; end BI
#endif ; end S19/BI6

#ifdef RGB4
    btfsc        demo_mode,0
    bsf          in1,7  
#endif ; RGB4

#ifdef SRGB
    movlw        b'00111000'
    btfsc        demo_mode,0
    movwf        in4 
#endif ; SRGB

    movlw        0xFF
    call         display_1bit

    clrf         in0
    clrf         in1
    clrf         in2
    movlw        0x01
    call         display_1bit
    return
#endif ; M8X16

;**********************************************************************
setup_pattern_table
;**********************************************************************
   var tbl_hi
   var tbl_low
   var pattern_temp
; New code optimized for new pics   DDF enhancement

  movlw        HIGH MasterTable
  movwf        FSR1H
  movlw        LOW MasterTable
  movwf        FSR1L
  incf         pattern,w
  movwf        pattern_temp

loop
  MOVIW FSR1++
  movwf tbl_hi
  MOVIW FSR1++
  movwf tbl_low
  DECFSZ pattern_temp,1
  goto loop

  movfw tbl_low
  movwf FSR1L
  movfw tbl_hi
  bsf   tbl_hi,7  ;set bit 7 high      (microchip example does not have this?)
  movwf FSR1H
  return

#ifdef DEAD
;**********************************************************************
setup_pattern_table_old ; obs code now using IND1 to lookup table entries.
;**********************************************************************
    var tbl_hi
    var tbl_low
    var temp_high
;
;   Set the pattern (table)
;
    movlw        HIGH MasterTable
    movwf        tbl_hi
    movlw        LOW MasterTable
    movwf        tbl_low

;   get the high address for the pattern table
    bcf          STATUS,0      ; clear carry flag
    rlf          pattern,w     ; entry = table * 2
    movwf        pindex
    bcf          INTCON, GIE      ; disable INTs
    call         table_lookup
    bsf          INTCON, GIE      ; enable INTs
    movwf        temp_high          ; can't put it in tbl_high yet

;   get the low address for the pattern table
    bsf          STATUS,0      ; set carry
    rlf          pattern,w     ; entry = table * 2 + 1
    movwf        pindex
    bcf          INTCON, GIE      ; disable INTs
    call         table_lookup
    bsf          INTCON, GIE      ; enable INTs
    movwf        tbl_low

    movf         temp_high,w
    movwf        tbl_hi

sreturn
    return
#endif
;**********************************************************************
get_next_pattern_entry
;**********************************************************************
;
;  rewrite for new chips using indirect addressing of program flash DDF BUG!!
;


#ifndef NOEEPROM
;   if hi address is 0x21 pattern is in eeprom   ; This could be F000 now DDF BUG!!
    movlw        0xf0
    subwf        tbl_hi,w
    btfss        STATUS,Z
    goto         in_mem

;   table in eeprom
    movfw        tbl_low
    addwf        pindex,w

    call         read_eeprom
    
    incfsz       pindex,f
    goto         greturn1
    incf         pindex1,f
    goto         greturn1
#endif

;   table in program memory

in_mem

    MOVIW FSR1++

greturn1
    return


#ifdef DEAD
;**********************************************************************
get_next_pattern_entry_old ; obs code now using IND1 to lookup table entries.
;**********************************************************************
    var          pclath_save
    var          temp2

#ifndef NOEEPROM
;   if hi address is 0x21 pattern is in eeprom   ; This could be F000 now DDF BUG!!
    movlw        0xf0
    subwf        tbl_hi,w
    btfss        STATUS,Z
    goto         glabel1

;   table in eeprom
    movfw        tbl_low
    addwf        pindex,w

    call         read_eeprom
    
    goto         greturn
#endif

;   table in program memory

glabel1

    bcf          INTCON, GIE      ; disable INTs
    movfw        PCLATH
    movwf        pclath_save

    movfw        tbl_hi
    addwf        pindex1,w
    movwf        offset_hi

    bcf          STATUS,C
    movfw        tbl_low
    addwf        pindex,w
    movwf        offset_low

    btfsc        STATUS,C
    incf         offset_hi,f
    call         jump_address

    movwf        temp2
    movfw        pclath_save
    movwf        PCLATH
    movfw        temp2
    bsf          INTCON, GIE      ; enable INTs

greturn
    incfsz       pindex,f
    goto         gskip
    incf         pindex1,f
gskip
    return
#endif

#ifndef NOEEPROM
;**********************************************************************
write_eeprom
;   expects EEPROM address and data in pindex and input
;   makes sure previous write (if any) has completed before proceeding
;**********************************************************************
    BANKSEL EECON1

    btfsc   EECON1,WR       ;wait for WR to clear
    goto    $-1

    bcf          INTCON, GIE      ; disable INTs
    bsf     EECON1,WREN     ;enable writes
    BANKSEL EEADR
    movf    pindex,w        ;set address
    movwf   EEADR
    movf    input,w         ;set data
    movwf   EEDAT
    BANKSEL EECON1
    movlw   0x55            ;EECON2 = 0x55  ;unlock sequence
    movwf   EECON2
    movlw   0xAA            ;EECON2 = 0xAA  ;unlock sequence
    movwf   EECON2
    bsf     EECON1,WR       ;initiate a write cycle
    bsf          INTCON, GIE      ; enable INT

    MOVLB 0x00
    return


;**********************************************************************
read_eeprom
;   expects EEPROM address in W
;   returns EEPROM data in W
;   makes sure previous write (if any) has completed before proceeding
;**********************************************************************
    bcf     INTCON, GIE      ; disable INTs

    BANKSEL EECON1
    btfsc   EECON1,WR       ;wait for WR to clear
    goto    $-1

    bcf     EECON1,WREN     ;disable writes
    BANKSEL EEADR
    movwf   EEADR           ;EEADR = W
    BANKSEL EECON1
    bcf     EECON1,7        ;clear EEPGD
    bsf     EECON1,RD       ;initiate a read cycle
    BANKSEL EEDAT
    movf    EEDAT,w         ;W = EEDAT

    BANKSEL INTCON
    bsf          INTCON, GIE      ; enable INT
    return
#endif

;**********************************************************************
read_demo_mode
;**********************************************************************
#ifndef NOEEPROM
    movlw        LOW demo_store
    call         read_eeprom
#else
    movlw        0x00
#endif
	movwf        demo_mode
    return

;**********************************************************************
toggle_demo
;**********************************************************************
    call         read_demo_mode
#ifndef NOEEPROM
    btfss        demo_mode,0          ;
    goto         tdemo_on

;   toggle off
    bcf          demo_mode,0
    goto         tdemo_cont

tdemo_on
    bsf          demo_mode,0

tdemo_cont
    movlw        LOW demo_store
    movwf        pindex
    movfw        demo_mode
    movwf        input
    call         write_eeprom

    call         display_pattern_id
    call         display_pattern_id
#endif
    return


;**********************************************************************
pattern_driver
;**********************************************************************

    var pattern
    var tbltype
    var in0
    var in1
    var in2
#ifdef C12
    var in3
    var in4
    var in5
#endif
#ifdef C19
    var in3
    var in4
    var in5
    var in6
    var in7
    var in8
    var in9
#endif
#ifdef SRGB
    var in3
    var in4
    var in5
    var in6
    var in7
    var in8
    var in9
    var in10
    var in11
    var in12
#endif
#ifdef BADGE
    var in3
#endif
#ifdef M8X16
   var in3
   var in4
   var in5
   var in6
   var in7
   var in8
   var in9
   var ina
   var inb
   var inc
   var ind
   var ine
   var inf
   var in10
   var in11
   var in12
   var in13
   var in14
   var in15
   var in16
   var in17
   var in18
   var in19
   var in1a
   var in1b
   var in1c
   var in1d
   var in1e
   var in1f
#endif
    var speed
    var pspeed
    var demo_mode
    var psize

    ; need to be able to access from page1 & page2 for eeprom read/write
    var_all_bank pindex          ; pattern index
    var_all_bank pindex1         ; pattern index
    var_all_bank input

ptop

    call         setup_pattern_table

    clrf         pindex
    clrf         pindex1

;   load the table type  (Currently only 1 type)
    call         get_next_pattern_entry
    movwf        tbltype
    bcf          tbltype,7     ; using top bit for demo mode.

;   load the speed (someday this will be a table type 1 only thing.)
    call         get_next_pattern_entry
    movwf        pspeed
    incf         pspeed,f          ; adjust so 0 is fastest, not treated like speed 256

; load the table size
    call         get_next_pattern_entry ;4rgb
    movwf        psize                  ;4rgb

ploop0
;
;   Check for IR command in
;
    btfss        IR_in_good,0
    goto         button_check

blinkie_check
    movlw        0x07              ; blinkines use address 0x07 (Experimental)
    subwf        address,w
    btfss        STATUS,Z
    goto         remote_check    

    call         set_pattern
    clrf         IR_in_good
    goto         ptop

remote_check
    movf         address,f         ; remote giving "0" for address (TV)?
    btfss        STATUS,Z
    goto         button_check

    movlw        0x20              ; remote curser right (pattern ++)
    subwf        command,w
    btfsc        STATUS,Z
    call         next_pattern

    movlw        0x21              ; remote curser left (pattern --)
    subwf        command,w
    btfsc        STATUS,Z
    call         past_pattern

    movlw        0x00              ; remote "0" key  (pattern = 0)
    subwf        command,w
    btfsc        STATUS,Z
    clrf         pattern

    movlw        0x0c              ; remote on/off key (togle demo mode!)
    subwf        command,w
    btfsc        STATUS,Z
    call         toggle_demo

    clrf         IR_in_good
    goto         ptop

button_check
; ploop1

    movfw        button      ; if any putton pressed show pattern id
    btfsc        STATUS,Z
    goto         ploop2

    call         display_pattern_id
    call         display_pattern_id

ploop1a

#ifdef M3X3
    movlw        0x03              ; if button 3 & 4 presses
    subwf        button,w
    btfsc        STATUS,Z
    goto         mode_loop

    movlw        0x0C              ; if button 1 & 2 presses
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   

#endif

#ifdef M8X16
    movlw        0x03              ; if both buttons pressed
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   
#endif
#ifdef C12
    movlw        0x03              ; if both buttons pressed
    subwf        button,w
    btfsc        STATUS,Z
    call         toggle_demo   
#endif


    btfsc        button,0    ; if button 3 pressed inc pattern
    goto         ploop1up

    btfsc        button,1    ; if button 4 pressed dec pattern
    goto         ploop1down

    goto         ptop

ploop1up
    call         next_pattern
    call         display_pattern_id
    call         display_pattern_id
    goto         ploop1a

ploop1down
    call         past_pattern
    call         display_pattern_id
    call         display_pattern_id
    goto         ploop1a
ploop2

#ifdef PATTERN1
    movlw        0x01              ; pattern1
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_1
#endif

#ifdef PATTERN2
    movlw        0x02              ; pattern2
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_2
#endif

#ifdef PATTERN3
    movlw        0x03              ; pattern3
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_3
#endif

#ifdef PATTERN4
    movlw        0x04              ; pattern4
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_4
#endif

#ifdef PATTERN5
    movlw        0x05              ; pattern5
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_5
#endif

#ifdef PATTERN6
    movlw        0x06              ; pattern6
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_6
#endif

#ifdef PATTERN7
    movlw        0x07              ; pattern7
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_7
#endif

#ifdef PATTERN8
    movlw        0x08              ; pattern8
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_8
#endif

#ifdef PATTERN9
    movlw        0x09              ; pattern9
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_9
#endif

#ifdef PATTERN10
    movlw        0x0A              ; pattern10
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_10
#endif

#ifdef PATTERN11
    movlw        0x0B              ; pattern11
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_11
#endif

#ifdef PATTERN12
    movlw        0x0C              ; pattern12
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_12
#endif

#ifdef PATTERN13
    movlw        0x0D              ; pattern13
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_13
#endif

#ifdef PATTERN14
    movlw        0x0E              ; pattern14
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_14
#endif

#ifdef PATTERN15
    movlw        0x0F              ; pattern15
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_15
#endif

#ifdef PATTERN16
    movlw        0x10              ; pattern16
    subwf        tbltype,w
    MOVLP    high table_type_16
    btfsc        STATUS,Z
    call         table_type_16
    MOVLP    high pattern_driver
#endif

#ifdef PATTERN17
    movlw        0x11              ; pattern17
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_17
#endif

#ifdef PATTERN18
    movlw        0x12              ; pattern18
    subwf        tbltype,w
    MOVLP    high table_type_18
    btfsc        STATUS,Z
    call         table_type_18
    MOVLP    high pattern_driver
#endif

#ifdef PATTERN19
    movlw        0x13              ; pattern19
    subwf        tbltype,w
    MOVLP    high table_type_19
    btfsc        STATUS,Z
    call         table_type_19
    MOVLP    high pattern_driver
#endif

#ifdef PATTERN20
    movlw        0x14              ; pattern20
    subwf        tbltype,w
    MOVLP    high table_type_20
    btfsc        STATUS,Z
    call         table_type_20
    MOVLP    high pattern_driver
#endif

#ifdef PATTERN21
    movlw        0x15              ; pattern21
    subwf        tbltype,w
    MOVLP    high table_type_21
    btfsc        STATUS,Z
    call         table_type_21
    MOVLP    high pattern_driver
#endif

#ifdef PATTERN22
    movlw        0x16              ; pattern22
    subwf        tbltype,w
    PAGESEL      table_type_22
    btfsc        STATUS,Z
    call         table_type_22
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN23
    movlw        0x17              ; pattern23
    subwf        tbltype,w
    PAGESEL      table_type_23
    btfsc        STATUS,Z
    call         table_type_23
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN24
    movlw        0x18              ; pattern24
    subwf        tbltype,w
    PAGESEL      table_type_24
    btfsc        STATUS,Z
    call         table_type_24
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN25
    movlw        0x19              ; pattern25
    subwf        tbltype,w
    PAGESEL      table_type_25
    btfsc        STATUS,Z
    call         table_type_25
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN26
    movlw        0x1a              ; pattern26
    subwf        tbltype,w
    PAGESEL      table_type_26
    btfsc        STATUS,Z
    goto         table_type_26     ; to save stack we use "goto" to pattern_return
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN27
    movlw        0x1b              ; pattern27
    subwf        tbltype,w
    PAGESEL      table_type_27
    btfsc        STATUS,Z
    goto         table_type_27     ; to save stack we use "goto" to pattern_return
    PAGESEL      pattern_driver
#endif

#ifdef PATTERN28
    movlw        0x1c              ; pattern28
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_28
#endif

#ifdef PATTERN29
    movlw        0x1d              ; pattern29
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_29
#endif

#ifdef PATTERN30
    movlw        0x1e              ; pattern30
    subwf        tbltype,w
    btfsc        STATUS,Z
    call         table_type_30
#endif

pattern_return

;   make sure we are not sending a IR signel
    movf        scount,w                    ; F22
    addlw       0                           ; F23
    btfss       STATUS,Z                    ; F24
    goto        ploop3

;   count down till net IR signel
    btfss       nextf,1
    goto        ploop3

    bcf         nextf,1
    btfss       demo_mode,0
    goto        ploop2a

    call        next_pattern
    goto        ptop
   
ploop2a
;   send an IR signel
#ifdef ENABLE_IR
    movlw       0x07                        ; address 0x07 "Experimental"
    movwf       out_address
    movfw       out_pattern
    movwf       out_command                 ; copy out_pettern

    call        rf_command_out 
#endif

ploop3
    decfsz  psize,f     ;check for end of pattern (4rgb)
    goto    ploop0

    goto        ptop


#ifdef PATTERN1
#include pattern_01.asm
#endif
#ifdef PATTERN2
#include pattern_02.asm
#endif
#ifdef PATTERN3
#include pattern_03.asm
#endif
#ifdef PATTERN4
#include pattern_04.asm
#endif
#ifdef PATTERN5
#include pattern_05.asm
#endif
#ifdef PATTERN6
#include pattern_06.asm
#endif

#define BRIGHT1 0x40
#define BRIGHT2 0xA0

#ifdef PATTERN7
#include pattern_07.asm
#endif
#ifdef PATTERN19
#include pattern_19.asm
#endif
#ifdef PATTERN8
#include pattern_08.asm
#endif
#ifdef PATTERN9
#include pattern_09.asm
#endif
#ifdef PATTERN10
#include pattern_10.asm
#endif
#ifdef PATTERN11
#include pattern_11.asm
#endif

#ifdef RANDOM

;**********************************************************************
gen_random
;**********************************************************************

   var     random

   RLF     random,W
   RLF     random,W
   BTFSC   random,4
   XORLW   1
   BTFSC   random,5
   XORLW   1
   BTFSC   random,3
   XORLW   1
   MOVWF   random
   return
#endif

#ifdef PATTERN12
#include pattern_12.asm
#endif
#ifdef PATTERN13
#include pattern_13.asm
#endif
#ifdef PATTERN14
#include pattern_14.asm
#endif
#ifdef PATTERN15
#include pattern_15.asm
#endif
#ifdef PATTERN17
#include pattern_17.asm
#endif
#ifdef PATTERN22
#include pattern_22.asm
#endif
#ifdef PATTERN23
#include pattern_23.asm
#endif

#ifdef M8X16
;**********************************************************************
shift_left
;**********************************************************************
;
;  shift the in1f->in1e->in1d->....->in1->in0
;


    movlw        LOW in0        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H

    movlw        0x1f
    movwf        fcount1

t23_loop

     MOVIW INDF0++   ; inc INDFO (don't use W)
     MOVIW INDF0--   ; get W, dec INDF0
     MOVWI INDF0++   ; put W, inc INDF0
      
    decfsz       fcount1,f
    goto         t23_loop

    return
#endif

#ifdef PATTERN24
#include "pattern_24.asm"
#endif
#ifdef PATTERN25
#include "pattern_25.asm"
#endif
#ifdef PATTERN26
#include "pattern_26.asm"
#endif
#ifdef PATTERN28
#include "pattern_28.asm"
#endif
#ifdef PATTERN29
#include "pattern_29.asm"
#endif
#ifdef PATTERN30
#include "pattern_30.asm"
#endif

#ifdef DISPLAY_1BIT_A
#include display_1bit_a.asm   ; Mono 6 circle / mono badge / mono 6 dogtag
#endif
#ifdef DISPLAY_1BIT_B
#include display_1bit_b.asm   ; Bicolor 19 circle / mono 19 circle/ mono 19 circle
#endif
#ifdef DISPLAY_1BIT_C
#include display_1bit_c.asm   ; 4RGB / bicolor 6 circle / Bicolor Badge / bicolor 6 dogtag / 2RGB dogtag
#endif
#ifdef DISPLAY_1BIT_D
#include display_1bit_d.asm   ; mono 19 Stick 
#endif
#ifdef DISPLAY_1BIT_GATOR
#include display_1bit_gator.asm   ; gator
#endif
#ifdef DISPLAY_1BIT_ROCKET
#include display_1bit_rocket.asm   ; rocket
#endif
#ifdef DISPLAY_1BIT_BADGE_G2
#include display_1bit_badge_g2.asm   ; badge G2
#endif
#ifdef DISPLAY_1BIT_F 
#include display_1bit_f.asm   ; bicolor 3x3 matrix / mono 3x3 matrix
#endif
#ifdef DISPLAY_1BIT_G
#include display_1bit_g.asm   ; 16x8x2 matrix
#endif
#ifdef DISPLAY_1BIT_H
#include display_1bit_h.asm   ; bicolor & mono 12 LED circle / bicolor & mono 24 LED sphere
#endif
#ifdef DISPLAY_1BIT_I
#include display_1bit_i.asm   ; D10
#endif

#ifdef DISPLAY_2BIT_A         ; Mono 6 circle / mono badge / mono 6 dogtag
#include display_2bit_a
#endif

#ifdef DISPLAY_2BIT_C
#include display_2bit_c       ;  4RGB / D10 / bicolor 6 circle / Bicolor Badge / bicolor 6 dogtag
#endif

#define BRIGHT1H 0xA0
#define BRIGHT2H 0x40

#ifdef DISPLAY_2BIT_D
#include display_2bit_d       ; mono 19 Stick
#endif

#ifdef DISPLAY_2BIT_E
#include display_2bit_e       ; mono 19 circle
#endif

#ifdef DISPLAY_1BIT_E
#include display_1bit_e    ; RGB Stick Anode / cathode
#endif

;**********************************************************************
;   IR Tester
;**********************************************************************
IR_Tester
    movlw       b'00000000'  ; Red Eye!
    movwf       in0
    movlw       b'00000000'
    movwf       in1
    movlw       b'10000000'
    movwf       in2

    movlw       0xff
    call        display_1bit

    movlw       b'00000000'
    movwf       in2

    movlw       0xff
    call        display_1bit

    movlw       b'10000000'
    movwf       in2

    movlw       0xff
    call        display_1bit

    movlw       b'00000000'
    movwf       in2

    movlw       0xff
    call        display_1bit

    movlw       b'10000000'
    movwf       in2

    movlw       0xff
    call        display_1bit


itop
    movlw        0x02
    subwf        instate,w
    btfss        STATUS,C
    clrw
    movwf        in0
    
    movlw        0x00
    movwf        in1

    movlw        0x01
    call         display_1bit       

;
;   Check for push button
;
ibutton
    movf        button,w
    btfsc       STATUS,Z
    goto        iloop1
    clrf        max_instate
    clrf        instate

    movf        scount,w                    ; if sending an IR command ignore button
    addlw       0                           ; not sure if needed
    btfss       STATUS,Z                   
    goto        ibutton    

    movf        button,w                    ; 2st 8 bits are the buttons
    movwf       in1
    clrf        in0                         ; next 8 are zero
;    movlw       0x80
;    movwf       in2                         ; led 17 is on

#ifdef M8X16
    movfw       button
    movwf       in3
#endif

    movlw       0x01
    call        display_1bit

;   send an IR signel
    clrf        out_address                 ; address 0x00 "TV remote"

#ifdef M3X3

    movlw        0x03              ; if button 3 & 4 presses
    subwf        button,w
    btfsc        STATUS,Z
    goto         mode_loop

    btfsc        button,0    ; if button 3 pressed 
    goto         send_chan_up

    btfsc        button,1    ; if button 4 pressed 
    goto         send_chan_down

    btfsc        button,2    ; if button 1 pressed 
    goto         send_vol_up

    btfsc        button,3    ; if button 2 pressed 
    goto         send_vol_down

    btfsc        button,4    ; if button 5 pressed 
    goto         send_on_off

send_chan_up
    movlw       0x20
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_chan_down
    movlw       0x21
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_vol_up
    movlw       0x10
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

send_vol_down
    movlw       0x11
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton

#endif

send_on_off
    movlw       0x0c
    movwf       out_command                 ; code 0x0c (on/off)
    call        rf_command_out
    goto        ibutton


;
;   Check for IR Command
;
iloop1
    btfss       IR_in_good,0
    goto        itop
    clrf        IR_in_good

;  flash all LEDs Red
    movlw       0xF0
    movwf       in0
    clrf        in1

    movlw       0x7f
    call        display_1bit    

;   flash all LEDs off
    clrf        in0
    clrf        in1

    movlw       0x3f
    call        display_1bit

;   flash all LEDs Red
    movlw       0xF0
    movwf       in0
    clrf        in1

    movlw       0x7f
    call        display_1bit

;   display command and address
    movf        command,w
    movwf       in0
    movf        address,w
    movwf       in1

    movlw       0xff
    call        display_1bit
    movlw       0xff
    call        display_1bit
    clrf        max_instate
    clrf        instate

    goto        itop

#ifdef M3X3
#include m3x3_dice.asm
#endif

;
; M A I N
;
;**********************************************************************
main
;**********************************************************************
    clrf        PORTA
    clrf        TMR0 
    clrf        pattern
;    movlw       0x0c
;    movwf       pattern
    clrf        scount
    clrf        toggle
    clrf        address
    clrf        command
    clrf        IR_lhalf
    clrf        instate
    clrf        max_instate
    clrf        IR_in_good
    clrf        dcycle
    clrf        count1
    clrf        count2
    clrf        button
#ifdef PATTERN2
    clrf         delay1
    clrf         fad
    clrf         color
#endif
#ifndef C12
#ifndef C19
#ifndef M3X3
#ifdef MONO
	clrf Br_reg
	clrf Bg_reg
	clrf Bb_reg
	clrf Dr_reg
	clrf Dg_reg
	clrf Db_reg
#endif
#endif
#endif
#endif

   BANKSEL OSCCON

#ifdef __16F1938
;            +------------- PLL enable (1)
;            |++++--------- 8MHZ/32MHZ (1110)
;            ||||| ++------ Internal OSC (1x)
;            ||||| ||
   movlw   b'01110000'     ;switch to 32 MHz clock, PLL is set on in config1, bit 7 ignored.
#else
#ifdef __16F1936

;             +------------- PPL disable (0)
;             |++++--------- OSC 8MHZ (1110)
;             ||||| ++------ System Clock Internal (1x)
;             ||||| ||
    movlw   b'01110010'     ;switch to 8 MHz clock
#else
    movlw   b'01110010'     ;switch to 8 MHz clock
#endif
#endif

    movwf  OSCCON

#ifdef __12F1822
    BANKSEL ANSELA
    clrf    ANSELA           ;set pins to digital

#else
#ifdef __16F1824
    BANKSEL ANSELA
    clrf    ANSELA           ;set pins to digital
    BANKSEL LATA
    clrf    LATA


    BANKSEL ANSELC
    clrf    ANSELC
    BANKSEL LATC
    clrf    LATC
#else
#ifdef __16F1936
    BANKSEL ANSELA
    clrf    ANSELA           ;set pins to digital
    BANKSEL LATA
    clrf    LATA

    BANKSEL LATB
    clrf    LATB
    BANKSEL ANSELB
    clrf    ANSELB
#else
    BANKSEL ANSEL 
    clrf    ANSEL           ;set pins to digital
#endif
#endif

#endif


   BANKSEL OPTION_REG

; set up TMR0 & pullups
;             +---------- disable pullups (1)
;             |+--------- interrupt edge select (don't care)
;             ||+-------- TMR0 source = internal clock (0)
;             |||+------- TMR0 source edge select (don't care)
;             ||||+------ assign prescaler to TMR0 (0)
;             |||||+++--- prescaler set to 8X (010)
;             |||||||| 
    movlw   b'10000010'
    movwf   OPTION_REG

#ifdef C19
;   enable pullups on portA
    bcf         OPTION_REG,NOT_WPUEN

;   input on A5
    BANKSEL      WPUA
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,5     ; enable pullup A5
    BANKSEL      WPUC
    clrf         WPUC       ; disable all pullups
#endif

#ifdef RGB2_DOGTAG
;   enable pullups on portA
    BANKSEL     OPTION_REG
    bcf         OPTION_REG,NOT_WPUEN

;   input on A3
    BANKSEL      WPUA
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,3     ; enable pullup A3
#endif

#ifdef BI6_DOGTAG
;   enable pullups on portA
    BANKSEL     OPTION_REG
    bcf         OPTION_REG,NOT_WPUEN

;   input on A3
    BANKSEL      WPUA
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,3     ; enable pullup A3
#endif

#ifdef SRGB
;   enable pullups on portA
    bcf         OPTION_REG,NOT_RAPU

;   input on A5
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,5     ; enable pullup A5
    bsf          WPUA,4     ; enable pullup A4
#endif

#ifdef C12 
;   BANKSEL OPTION_REG
;   bsf     OPTION_REG, NOT_RBPU
;
;  input C7,C5 buttons
;  input C6 IR.
   BANKSEL TRISC
    movlw   b'11100000'
    movwf   TRISC   ; C7,C6,C5 input
#endif

#ifdef GATOR 
;
;  input A3 IR.
   BANKSEL TRISA
    movlw   b'00001000'
    movwf   TRISA   ; A3 Input
#endif

#ifdef M8X16
;  E1 - IR/Button
;  C2 - Button2
;  C1 - IR out
;  C3/C4 - I2C
;  C0,C5,C6,C7 - strobe select output
   BANKSEL TRISC
    movlw   b'00011100'
    movwf   TRISC   ; C7,C6,C5,C1,C0 output
    clrf    TRISA   ; all A output
    clrf    TRISB   ; all B output
    movlw   b'00001000'
    movwf   TRISE   ; E3 input
#endif

#ifdef D10
;  A0,A1,A2,A4 - LEDs
;  A3,A5 Push Button
   BANKSEL TRISA
    movlw   b'00101000'
    movwf   TRISA  

;   enable pullups on portA
    BANKSEL     OPTION_REG
    bcf         OPTION_REG,NOT_RAPU

;   input on A5
    BANKSEL      WPUA
    clrf         WPUA       ; disable all pullups
    bsf          WPUA,5     ; enable pullup A5
    bsf          WPUA,3     ; enable pullup A3

    BANKSEL      CMCON0
    movlw        0x07
    movwf        CMCON0

    BANKSEL     ANSEL
    clrf        ANSEL           ;set pins to digital
#endif


    BANKSEL     button 
    clrf        button

#ifdef RANDOM
    movlw       0x1D
    movwf       random
#endif

;   enable timer0 interupt
#ifdef __16F1938
    bsf     INTCON,TMR0IE
#else
#ifdef __16F1936
    bsf     INTCON,TMR0IE
#else
    bsf     INTCON,T0IE
#endif
#endif
    bsf     INTCON,GIE

;  flash all LEDs on     This kills some time, allowing us to sample the button and IR-Rx
#ifdef M8X16
#ifdef __16F1938
    movlw        LOW in0        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H
#else
    movlw   in0
    movwf   FSR
#endif
    movlw   0x20
    movwf   fcount1

    movlw   0xFF
loop_set_on
    movwf   INDF0
    incf         FSR0L,f

    decfsz  fcount1,f
    goto    loop_set_on
#else
    movlw   b'11111111'
;     movlw   b'01000000' 

    movwf   in0
    movwf   in1
    movwf   in2
#ifdef C19
    movwf   in3
    movwf   in4
#endif
#ifdef SRGB
    movwf   in3
    movwf   in4
    movwf   in5
#endif
#endif

#ifdef C12a                 ; going to flash the config1 value!
    movfw   config1
    movwf   fcount1        ; flash 1 - mono single, 2 - mono dual  3 - bi single or 4 - bi dual
    incf    fcount1,f

flash_loop
    movlw   b'10101010'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    movlw   b'01010101'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    decfsz  fcount1,f
    goto    flash_loop

    movlw   b'11111111'
    movwf   in0
    movwf   in1
    movwf   in2
    movwf   in3
    movwf   in4

#endif


    movlw   0xff            ; allways flash once
    call    display_1bit
    movlw   0xff
    call    display_1bit

#ifdef M3X3                 ; have to wait for the IR to go high, and the buttons to de-bounce on 3x3 powerup
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit
#endif


; Trun all the LEDs off
#ifdef M8X16
#ifdef __16F1938
    movlw        LOW in0        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H
#else
    movlw   in0
    movwf   FSR
#endif
    movlw   0x20
    movwf   fcount1

    movlw   0x00
loop_set_off
    movwf   INDF0

    incf         FSR0L,f

    decfsz  fcount1,f
    goto    loop_set_off
#else
    clrf   in0
    clrf   in1
    clrf   in2
#ifdef C19
    clrf   in3
    clrf   in4
#endif
#ifdef SRGB
    clrf   in3
    clrf   in4
    clrf   in5
#endif
#endif
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

    call read_demo_mode

    movfw   button
    movwf   in1
    movlw   0xff
    call    display_1bit
    movlw   0xff
    call    display_1bit

#ifndef M3X3 
;   if button pressed durring powerup run IR_Tester
;   else run pattern driver
;
    btfss       button,0          
    goto        pattern_driver
    call        toggle_demo
#ifdef ENABLE_IR
    goto        IR_Tester
#else
    goto        pattern_driver
#endif
#else
#inclue m3x3_menu.asm
#endif

#ifdef DEAD
;**********************************************************************
table_lookup_old ; obs code now using IND1 to lookup table entries.
;**********************************************************************
    movf         tbl_hi,w
    movwf        PCLATH
    movf         pindex,w
    addwf        tbl_low,w
    btfsc        STATUS,0     ; check carry flag
    incf         PCLATH,f
    movwf        PCL

;**********************************************************************
jump_address_old ; obs code now using IND1 to lookup table entries.
;**********************************************************************
; Portability : clean
;
    var offset_hi
    var offset_low

    movf         PCLATH,w
    movwf        pclath_save
    movf         offset_hi,w
    movwf        PCLATH

    movf         offset_low, w
    movwf        PCL
#endif

;**********************************************************************
MasterTable
;**********************************************************************
    make_mtab NUM_TAB


#ifdef PATTERN16
#define BRIGHT1_lo 0x04
#define BRIGHT2_lo 0x0A
#define BRIGHT1_hi 0x40
#define BRIGHT2_hi 0xA0

;**********************************************************************
table_type_16
;**********************************************************************
;
;  1 bytes
;
;  ABBCCCCC
;
;  A = shire Right/Left
;  BB = two bit intensity to shift on
;  CCCCC = Number of shifts to loop
;
;  if CCCCC = 0x11111, specical case: turn all LEDs off.

    var t7count
    var t17_loop

    pageselw get_next_pattern_entry
    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1
    pageselw table_type_16

    movlw        b'00011111'
    andwf        in0,w
    movwf        t7count

    movlw        b'00011111'  ; if shiftcount is 31, then clear all LEDs
    subwf        t7count,w
    btfss        STATUS,Z
    goto         t7_loop_red
    
    clrf         in0           ; quick way to clear all the LEDS.
    clrf         in1
    clrf         in2
    clrf         in3
    clrf         in4
    clrf         in5
    pageselw display_1bit
    call         display_1bit
    pageselw table_type_16
    goto         t7_return

t7_loop_red
    btfsc        in0,7
    goto         t7_set19_red

    call red_up
    goto         t7_loop_green

t7_set19_red

    call red_down

t7_loop_green
    btfsc        in0,6
    goto         t7_set19_green

    call green_up

    goto         t7_loop_blue
;
;   set LED 19
t7_set19_green

    call green_down

t7_loop_blue

    btfsc        in0,5
    goto         t7_set19_blue

    call blue_up

    goto         t7_cont
;
;   set LED 19
t7_set19_blue
    call  blue_dowm
t7_cont
    pageselw strobe_delay
    movf         pspeed,w
    call         strobe_delay
    pageselw t7_cont
;
;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t7_return

    btfsc        IR_in_good,0
    goto         t7_return

    decfsz       t7count,f
    goto         t7_loop_red

t7_return
    return

;**********************************************************************
red_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        A2_C1_reg   ; index = 13 R
    movwf        FSR

red_up_loop
    movfw        INDF        ; load R [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store R [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         red_up_loop
;
;   01 Red
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        INDF,f     ;01

    return

;**********************************************************************
red_down
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C2_C3_reg   ; index = 02 R
    movwf        FSR

red_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         red_down_loop
;
;   14 Red
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,6
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,7
    addwf        INDF,f     ;01

    return

;**********************************************************************
green_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C4_C1_reg   ; index = 13 G
    movwf        FSR

green_up_loop
    movfw        INDF        ; load G [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store G [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         green_up_loop
;
;   01 Green
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        INDF,f     ;01

    return

;**********************************************************************
green_down
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C0_C3_reg   ; index = 02 Green
    movwf        FSR

green_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         green_down_loop
;
;   14 Green
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,4
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,5
    addwf        INDF,f     ;01

    return


;**********************************************************************
blue_up
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C2_C1_reg   ; index = 13 G
    movwf        FSR

blue_up_loop
    movfw        INDF        ; load G [index]
    incf         FSR,f         ; index ++
    movwf        INDF        ; store G [index]

    decf         FSR,f         ; index - 2
    decf         FSR,f

    decfsz       t17_loop,f
    goto         blue_up_loop
;
;   01 blue
;
    incf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        INDF,f     ;01

    return


;**********************************************************************
blue_dowm
;**********************************************************************

    movlw        0x0d
    movwf        t17_loop

    movlw        C4_C3_reg   ; index = 02 Blue
    movwf        FSR

blue_down_loop
    movfw        INDF        ; load R [index]
    decf         FSR,f         ; index - 1
    movwf        INDF        ; store R [index]

    incf         FSR,f         ; index + 2
    incf         FSR,f

    decfsz       t17_loop,f
    goto         blue_down_loop
;
;   14 Green
;
    decf         FSR,f
    clrf         INDF
    movlw        BRIGHT1
    btfsc        in1,2
    addwf        INDF,f     ;01
    movlw        BRIGHT2
    btfsc        in1,3
    addwf        INDF,f     ;01

    return
#endif

;
; These are down here for memory placement
;

#ifdef DISPLAY_1BIT_E
#include display_1bit_e_part2   ; RGB Stick Anode / cathode
#endif

#ifdef PATTERN17
#include pattern_17_part2.asm
#endif

#ifdef PATTERN18
#include pattern_18.asm  
#endif

#ifdef PATTERN20
#include pattern_20.asm
#endif

#ifdef PATTERN21
#include pattern_21.asm
#endif

#ifdef C12
    ORG     0x800
#endif

#ifdef PATTERN27
#include "pattern_27.asm"
#endif

;
; These are the pattern tables
;


#ifdef RGB4
#include <patterns_4rgb.asm>
#endif

#ifdef SRGB
#include <patterns_stick_rgb.asm>
#endif

#ifdef BI6
#ifdef MONO
#ifdef BADGE
#include <patterns_6led+c.asm>
#else
#include <patterns_6led.asm>
#endif
#else
#ifdef BADGE
#include <patterns_6bi+c.asm>
#else
#include <patterns_6bi.asm>
#endif
#endif
#endif

#ifdef M3X3
#include <patterns_3x3.asm>
#endif

#ifdef S19
#include <patterns_19led_stick.asm>
#endif

#ifdef GATOR
#include <patterns_gator.asm>
#endif

#ifdef ROCKET
#include <patterns_rocket.asm>
#endif

#ifdef BADGE_G2
#include <patterns_badge_g2.asm>
#endif

#ifdef BI6_DOGTAG
#ifdef MONO
#include <patterns_6led_dog.asm>
#else
#include <patterns_6bi_dog.asm>
#endif
#endif

#ifdef RGB2_DOGTAG
#include <patterns_2rgb_dog.asm>
#endif

#ifdef C19
#ifdef MONO
#include <patterns_19mono_circle.asm>
#else
#include <patterns_19bi_circle.asm>
#endif
#endif

#ifdef M8X16
#include <patterns_8x16.asm>
#endif

#ifdef C12
#include <patterns_dual_12circle.asm>
#endif

   end