;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************


;**********************************************************************
table_type_19
;**********************************************************************
;
;  1 bytes
;
;  ABBCDDEE  xxxxFFFF
;
;  A = shift Right/Left
;  BB = Color1/Color2/Both
;  C = Row/Col
;  DD = two bit Red intensity to shift on
;  EE = two bit Green intensity to shift on
;  FFFF = Number of shifts to loop
;
;  if FFFF = 0x11111, specical case: turn all LEDs off.
;

    var t7count

    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1

    movlw        b'00001111'
    andwf        in1,w
    movwf        t7count

    movlw        b'00001111'  ; if shiftcount is 15, then clear all LEDs
    subwf        t7count,w
    btfss        STATUS,Z
    goto         t7_loop
    
    clrf         in0           ; quick way to clear all the LEDS.
    clrf         in1
    clrf         in2
    call         display_1bit
    goto         t7_return


t7_loop
    btfsc        in0,7            ; sift right or left?
    goto         t7_set19
;
;   set LED 1
    btfss        in0,6            ; Green?
    goto         r_green_skip
    movfw		 A4_A1_reg        ; 08G -> 09G
	movwf	 	 A5_A4_reg

	movfw		 A1_A0_reg        ; 07G -> 08G
    movwf		 A4_A1_reg

	movfw	 	 A5_A2_reg        ; 06G -> 07G
	movwf		 A1_A0_reg 

	movfw		 A4_A2_reg        ; 05G -> 06G
	movwf	 	 A5_A2_reg

	movfw		 A2_A0_reg        ; 04G -> 05G
	movwf		 A4_A2_reg

	movfw		 A5_A1_reg        ; 03G -> 04G
	movwf		 A2_A0_reg 

	movfw		 A5_A0_reg        ; 02G -> 03G
	movwf		 A5_A1_reg

	movfw		 A4_A0_reg        ; 01G -> 02G
	movwf		 A5_A0_reg

	clrf		 A4_A0_reg
    movlw        BRIGHT1
    btfsc        in0,0
    addwf        A4_A0_reg,f
    movlw        BRIGHT2
    btfsc        in0,1
    addwf        A4_A0_reg,f
r_green_skip
#ifndef MONO
;
;   set LED 1
    btfss        in0,5            ; Red ?
    goto         r_red_skip
    movfw		 A1_A4_reg        ; 08R -> 09R
	movwf	 	 A4_A5_reg

	movfw		 A0_A1_reg        ; 07R -> 08R
    movwf		 A1_A4_reg

	movfw	 	 A2_A5_reg        ; 06R -> 07R
	movwf		 A0_A1_reg 

	movfw		 A2_A4_reg        ; 05R -> 06R
	movwf	 	 A2_A5_reg

	movfw		 A0_A2_reg        ; 04R -> 05R
	movwf		 A2_A4_reg

	movfw		 A1_A5_reg        ; 03R -> 04R
	movwf		 A0_A2_reg 

	movfw		 A0_A5_reg        ; 02R -> 03R
	movwf		 A1_A5_reg

	movfw		 A0_A4_reg        ; 01R -> 02R
	movwf		 A0_A5_reg

	clrf		 A0_A4_reg
    movlw        BRIGHT1
    btfsc        in0,2
    addwf        A0_A4_reg,f
    movlw        BRIGHT2
    btfsc        in0,3
    addwf        A0_A4_reg,f
#endif
r_red_skip
    goto         t7_cont

;
;   set LED 19
t7_set19

    btfss        in0,6            ; Green?
    goto         l_green_skip

	movfw		 A5_A0_reg        ; 02G -> 01G
	movwf		 A4_A0_reg

	movfw		 A5_A1_reg        ; 03G -> 02G
	movwf		 A5_A0_reg

	movfw		 A2_A0_reg        ; 04G -> 03G
    movwf		 A5_A1_reg

	movfw		 A4_A2_reg        ; 05G -> 04G
	movwf		 A2_A0_reg

	movfw	 	 A5_A2_reg        ; 06G -> 05G
	movwf		 A4_A2_reg 

	movfw		 A1_A0_reg        ; 07G -> 06G
	movwf	 	 A5_A2_reg

    movfw		 A4_A1_reg        ; 08G -> 07G
	movwf		 A1_A0_reg 

	movfw	 	 A5_A4_reg        ; 09G -> 08G
    movwf		 A4_A1_reg

	clrf		 A5_A4_reg
    movlw        BRIGHT1
    btfsc        in0,0
    addwf        A5_A4_reg,f
    movlw        BRIGHT2
    btfsc        in0,1
    addwf        A5_A4_reg,f
l_green_skip

#ifndef MONO

    btfss        in0,5            ; Red?
    goto         l_red_skip

	movfw		 A0_A5_reg        ; 02R -> 01R
	movwf		 A0_A4_reg

	movfw		 A1_A5_reg        ; 03R -> 02R
	movwf		 A0_A5_reg

	movfw		 A0_A2_reg        ; 04R -> 03R
    movwf		 A1_A5_reg

	movfw		 A2_A4_reg        ; 05R -> 04R
	movwf		 A0_A2_reg

	movfw	 	 A2_A5_reg        ; 06R -> 05R
	movwf		 A2_A4_reg 

	movfw		 A0_A1_reg        ; 07R -> 06R
	movwf	 	 A2_A5_reg

    movfw		 A1_A4_reg        ; 08R -> 07R
	movwf		 A0_A1_reg 

	movfw	 	 A4_A5_reg        ; 09R -> 08R
    movwf		 A1_A4_reg

	clrf		 A4_A5_reg
    movlw        BRIGHT1
    btfsc        in0,2
    addwf        A4_A5_reg,f
    movlw        BRIGHT2
    btfsc        in0,3
    addwf        A4_A5_reg,f

#endif
l_red_skip

t7_cont

    movf         pspeed,w
    call         strobe_delay
;
;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t7_return

    btfsc        IR_in_good,0
    goto         t7_return

    decfsz       t7count,f
    goto         t7_loop

t7_return
    return

