;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_20
;**********************************************************************
;
;  6 bytes
;      0       1        
;  RRRRGGGG BBBBDDDD 
;  xx111110 00000000 
;  xx432109 87654321 
;  
;  DDDD = delay counter

;    pageselw get_next_pattern_entry
    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1

;   collected the 6 bits for the delay counter

    clrf         p2count
    
    btfsc        in1,3
    bsf          p2count,7

    btfsc        in1,2
    bsf          p2count,6

    btfsc        in1,1
    bsf          p2count,5

    btfsc        in1,0
    bsf          p2count,4

p20_loop
;   run through the up/down bits.

;1R 0x0f
    movlw        LOW Ar_reg
    movwf        FSR0L
    movlw        HIGH Ar_reg
    movwf        FSR0H

    btfsc        in0,7
    call         p18_led_up
    btfss        in0,7
    call         p18_led_down

;2R 0xf0
    movlw        LOW Br_reg
    movwf        FSR0L
    movlw        HIGH Br_reg
    movwf        FSR0H

    btfsc        in0,6
    call         p18_led_up
    btfss        in0,6
    call         p18_led_down

;3R 0xf0
    movlw        LOW Cr_reg
    movwf        FSR0L
    movlw        HIGH Cr_reg
    movwf        FSR0H


    btfsc        in0,5
    call         p18_led_up
    btfss        in0,5
    call         p18_led_down

;4R 0x0f
    movlw        LOW Dr_reg
    movwf        FSR0L
    movlw        HIGH Dr_reg
    movwf        FSR0H

    btfsc        in0,4
    call         p18_led_up
    btfss        in0,4
    call         p18_led_down
 
;1G 0xf0
    movlw        LOW Ag_reg
    movwf        FSR0L
    movlw        HIGH Ag_reg
    movwf        FSR0H

    btfsc        in0,3
    call         p18_led_up
    btfss        in0,3
    call         p18_led_down


;2G 0xf0
    movlw        LOW Bg_reg
    movwf        FSR0L
    movlw        HIGH Bg_reg
    movwf        FSR0H

    btfsc        in0,2
    call         p18_led_up
    btfss        in0,2
    call         p18_led_down


;3G 0xf0
    movlw        LOW Cg_reg
    movwf        FSR0L
    movlw        HIGH Cg_reg
    movwf        FSR0H

    btfsc        in0,1
    call         p18_led_up
    btfss        in0,1
    call         p18_led_down
 
;4G 0xf0
    movlw        LOW Dg_reg
    movwf        FSR0L
    movlw        HIGH Dg_reg
    movwf        FSR0H

    btfsc        in0,0
    call         p18_led_up
    btfss        in0,0
    call         p18_led_down

;1B 0xf0
    movlw        LOW Ab_reg
    movwf        FSR0L
    movlw        HIGH Ab_reg
    movwf        FSR0H

    btfsc        in1,7
    call         p18_led_up
    btfss        in1,7
    call         p18_led_down


;2B 0x0f
    movlw        LOW Bb_reg
    movwf        FSR0L
    movlw        HIGH Bb_reg
    movwf        FSR0H

    btfsc        in1,6
    call         p18_led_up
    btfss        in1,6
    call         p18_led_down
 
;3B 0xf0
    movlw        LOW Cb_reg
    movwf        FSR0L
    movlw        HIGH Cb_reg
    movwf        FSR0H

    btfsc        in1,5
    call         p18_led_up
    btfss        in1,5
    call         p18_led_down

;4B 0xf0
    movlw        LOW Db_reg
    movwf        FSR0L
    movlw        HIGH Db_reg
    movwf        FSR0H

    btfsc        in1,4
    call         p18_led_up
    btfss        in1,4
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay


;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t20_exit

    btfsc        IR_in_good,0
    goto         t20_exit

    decfsz       p2count,f
    goto         p20_loop

t20_exit
    return

;**********************************************************************
p18_led_up
;**********************************************************************

    incf        INDF0,f
    btfsc       STATUS,Z
    comf        INDF0,f
    return

;**********************************************************************
p18_led_down
;**********************************************************************

    movf        INDF0,f
    btfss       STATUS,Z
    decf        INDF0,f
    return

