;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_21
;**********************************************************************
;
;  6 bytes
;      0       1        
;  RGRGRGRG RGRGRGRG RGRGRGRG 
;  11223344 55667788 99DDDDDD
;  
;  DDDD = delay counter

    pageselw get_next_pattern_entry
    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2

;   collected the 6 bits for the delay counter

    movlw        b'00111111'
    andwf        in2,w
    movwf        p2count
    rlf          p2count,f
    rlf          p2count,f

p21_loop
;   run through the up/down bits.

#ifndef MONO
;1R
    movlw        A0_A4_reg
    movwf        FSR

    btfsc        in0,7
    call         p18_led_up
    btfss        in0,7
    call         p18_led_down

;2R
    movlw        A0_A5_reg
    movwf        FSR

    btfsc        in0,5
    call         p18_led_up
    btfss        in0,5
    call         p18_led_down

;3R
    movlw        A1_A5_reg
    movwf        FSR

    btfsc        in0,3
    call         p18_led_up
    btfss        in0,3
    call         p18_led_down

;4R
    movlw        A0_A2_reg
    movwf        FSR

    btfsc        in0,1
    call         p18_led_up
    btfss        in0,1
    call         p18_led_down
 
;5R 
    movlw        A2_A4_reg
    movwf        FSR

    btfsc        in1,7
    call         p18_led_up
    btfss        in1,7
    call         p18_led_down


;6R
    movlw        A2_A5_reg
    movwf        FSR

    btfsc        in1,5
    call         p18_led_up
    btfss        in1,5
    call         p18_led_down


;7R
    movlw        A0_A1_reg
    movwf        FSR

    btfsc        in1,3
    call         p18_led_up
    btfss        in1,3
    call         p18_led_down
 
;8R
    movlw        A1_A4_reg
    movwf        FSR

    btfsc        in1,1
    call         p18_led_up
    btfss        in1,1
    call         p18_led_down

;9R
    movlw        A4_A5_reg
    movwf        FSR

    btfsc        in2,7
    call         p18_led_up
    btfss        in2,7
    call         p18_led_down
#endif


;1G
    movlw        A4_A0_reg
    movwf        FSR

    btfsc        in0,6
    call         p18_led_up
    btfss        in0,6
    call         p18_led_down
 
;2G
    movlw        A5_A0_reg
    movwf        FSR

    btfsc        in0,4
    call         p18_led_up
    btfss        in0,4
    call         p18_led_down

;3G
    movlw        A5_A1_reg
    movwf        FSR

    btfsc        in0,2
    call         p18_led_up
    btfss        in0,2
    call         p18_led_down

;4G
    movlw        A2_A0_reg
    movwf        FSR

    btfsc        in0,0
    call         p18_led_up
    btfss        in0,0
    call         p18_led_down

;5G
    movlw        A4_A2_reg
    movwf        FSR

    btfsc        in1,6
    call         p18_led_up
    btfss        in1,6
    call         p18_led_down

;6G
    movlw        A5_A2_reg
    movwf        FSR

    btfsc        in1,4
    call         p18_led_up
    btfss        in1,4
    call         p18_led_down

;7G
    movlw        A1_A0_reg
    movwf        FSR

    btfsc        in1,2
    call         p18_led_up
    btfss        in1,2
    call         p18_led_down

;8G
    movlw        A4_A1_reg
    movwf        FSR

    btfsc        in1,0
    call         p18_led_up
    btfss        in1,0
    call         p18_led_down

;9G
    movlw        A5_A4_reg
    movwf        FSR

    btfsc        in2,6
    call         p18_led_up
    btfss        in2,6
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay


;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t21_exit

    btfsc        IR_in_good,0
    goto         t21_exit

    decfsz       p2count,f
    goto         p21_loop

t21_exit
    return

;**********************************************************************
p18_led_up
;**********************************************************************

    incf        INDF,f
    btfsc       STATUS,Z
    comf        INDF,f
    return

;**********************************************************************
p18_led_down
;**********************************************************************

    movf        INDF,f
    btfss       STATUS,Z
    decf        INDF,f
    return

