;**********************************************************************
table_type_26 ; 256 Led fader
;**********************************************************************

    movwf        speed              ;w has the speed/delay
;
; going to break good coding rules for compact code, reorder or move
; the Led_xxx vars and you break the code!
;

    dupvar temp_in,b2l_out_hi
    dupvar p26_loop, b2l_out_low

;   load up 32 inxx vars
    movlw        LOW in0        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH in0
    movwf        FSR0H


    movlw        0x20
    movwf        p26_loop

t26_loop1
    call         get_next_pattern_entry
    movwf        INDF0
    incf         FSR0L,f

    decfsz       p26_loop,f
    goto         t26_loop1

;   hardcode count to 64
    movlw        0x64
    movwf        p26_loop

t26_loop2

; process page 1 (0x20) Led_Gxx vars

    movlw        LOW Led_G00        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH Led_G00
    movwf        FSR0H



    movfw        in0
    call         p26_d2b_8bits
    movfw        in1
    call         p26_d2b_8bits
    movfw        in2
    call         p26_d2b_8bits
    movfw        in3
    call         p26_d2b_8bits

; process page 2 (0x60) Led_Gxx vars

    movlw        LOW Led_G40        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH Led_G40
    movwf        FSR0H


    movfw        in4
    call         p26_d2b_8bits
    movfw        in5
    call         p26_d2b_8bits
    movfw        in6
    call         p26_d2b_8bits
    movfw        in7
    call         p26_d2b_8bits
    movfw        in8
    call         p26_d2b_8bits
    movfw        in9
    call         p26_d2b_8bits
    movfw        ina
    call         p26_d2b_8bits
    movfw        inb
    call         p26_d2b_8bits
    movfw        inc
    call         p26_d2b_8bits
    movfw        ind
    call         p26_d2b_8bits
    movfw        ine
    call         p26_d2b_8bits
    movfw        inf
    call         p26_d2b_8bits

    movlw        LOW Led_R00        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH Led_R00
    movwf        FSR0H


    movfw        in10
    call         p26_d2b_8bits
    movfw        in11
    call         p26_d2b_8bits
    movfw        in12
    call         p26_d2b_8bits
    movfw        in13
    call         p26_d2b_8bits


    movlw        LOW Led_R40        ; shift down in1f->in0
    movwf        FSR0L
    movlw        HIGH Led_R40
    movwf        FSR0H


    movfw        in14
    call         p26_d2b_8bits
    movfw        in15
    call         p26_d2b_8bits
    movfw        in16
    call         p26_d2b_8bits
    movfw        in17
    call         p26_d2b_8bits
    movfw        in18
    call         p26_d2b_8bits
    movfw        in19
    call         p26_d2b_8bits
    movfw        in1a
    call         p26_d2b_8bits
    movfw        in1b
    call         p26_d2b_8bits
    movfw        in1c
    call         p26_d2b_8bits
    movfw        in1d
    call         p26_d2b_8bits
    movfw        in1e
    call         p26_d2b_8bits
    movfw        in1f
    call         p26_d2b_8bits


    movf         speed,w
    call         strobe_delay

    decfsz       p26_loop,f
    goto         t26_loop2

    goto         pattern_return

;**********************************************************************
p26_d2b_8bits
;**********************************************************************

    movwf        temp_in

    btfsc        temp_in,7
    call         p26_led_up
    btfss        temp_in,7
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,6
    call         p26_led_up
    btfss        temp_in,6
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,5
    call         p26_led_up
    btfss        temp_in,5
    call         p26_led_down

    incf         FSR0L,f

    btfsc        temp_in,4
    call         p26_led_up
    btfss        temp_in,4
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,3
    call         p26_led_up
    btfss        temp_in,3
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,2
    call         p26_led_up
    btfss        temp_in,2
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,1
    call         p26_led_up
    btfss        temp_in,1
    call         p26_led_down


    incf         FSR0L,f

    btfsc        temp_in,0
    call         p26_led_up
    btfss        temp_in,0
    call         p26_led_down


    incf         FSR0L,f

    return


;**********************************************************************
p26_led_up
;**********************************************************************

    incf        INDF0,f
    btfsc       STATUS,Z
    comf        INDF0,f
    return

;**********************************************************************
p26_led_down
;**********************************************************************

    movf        INDF0,f
    btfss       STATUS,Z
    decf        INDF0,f
    return

