;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_29
;**********************************************************************
;        +++------------------------------ RGB 1
;        |||+++--------------------------- RGB 2
;        ||||||++----+-------------------- RGB 3
;        ||||||||    |+++----------------- Fire
;        ||||||||    ||||++++----+++------ Running lights
;        ||||||||    ||||||||    |||+----- IR
;        ||||||||    ||||||||    ||||++++- Delay
;
;     0         1         2
;  AAABBBCC    CDDDEEEE    EEEFGGGG
;  
;  AAABBBCC    C - 3 RGB LEDs
;  DDD - flame LED
;  EEEE EEE - Running lights
;  F - (IR)  instant on/off flag
;  GGGG = delay counter

    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2


;   collected the 4 bits for the delay counter

    clrf         p2count
    
    btfsc        in2,3
    bsf          p2count,7

    btfsc        in2,2
    bsf          p2count,6

    btfsc        in2,1
    bsf          p2count,5

    btfsc        in2,0
    bsf          p2count,4

 

;   check the instant on/off flag.
    movfw        p2count
    btfsc        in2,4
    call         display_1bit

p29_loop
;   run through the up/down bits.

; 1st RGB Red
    movlw        high A4_A1_reg
    movwf        FSR0H
    movlw        low A4_A1_reg
    movwf        FSR0L

    btfsc        in0,7
    call         p18_led_up
    btfss        in0,7
    call         p18_led_down

;1st RGB Green
    movlw        high A4_A2_reg
    movwf        FSR0H
    movlw        low A4_A2_reg
    movwf        FSR0L

    btfsc        in0,6
    call         p18_led_up
    btfss        in0,6
    call         p18_led_down

;1st RGB Blue
    movlw        high A4_A0_reg
    movwf        FSR0H
    movlw        low A4_A0_reg
    movwf        FSR0L

    btfsc        in0,5
    call         p18_led_up
    btfss        in0,5
    call         p18_led_down

;2nd RGB Red
    movlw        high A1_A5_reg
    movwf        FSR0H
    movlw        low A1_A5_reg
    movwf        FSR0L

    btfsc        in0,4
    call         p18_led_up
    btfss        in0,4
    call         p18_led_down
 
;2nd RGB Green
    movlw        high A1_A2_reg
    movwf        FSR0H
    movlw        low A1_A2_reg
    movwf        FSR0L

    btfsc        in0,3
    call         p18_led_up
    btfss        in0,3
    call         p18_led_down


;2nd RGB Blue
    movlw        high A1_A4_reg
    movwf        FSR0H
    movlw        low A1_A4_reg
    movwf        FSR0L

    btfsc        in0,2
    call         p18_led_up
    btfss        in0,2
    call         p18_led_down


;3rd RGB Red
    movlw        high A0_A1_reg
    movwf        FSR0H
    movlw        low A0_A1_reg
    movwf        FSR0L

    btfsc        in0,1
    call         p18_led_up
    btfss        in0,1
    call         p18_led_down

;3rd RGB Green
    movlw        high A0_A2_reg
    movwf        FSR0H
    movlw        low A0_A2_reg
    movwf        FSR0L

    btfsc        in0,0
    call         p18_led_up
    btfss        in0,0
    call         p18_led_down
 
;3rd RGB Blue
    movlw        high A0_A4_reg
    movwf        FSR0H
    movlw        low A0_A4_reg
    movwf        FSR0L

    btfsc        in1,7
    call         p18_led_up
    btfss        in1,7
    call         p18_led_down


;Fire Top
    movlw        high A0_A5_reg
    movwf        FSR0H
    movlw        low A0_A5_reg
    movwf        FSR0L

    btfsc        in1,6
    call         p18_led_up
    btfss        in1,6
    call         p18_led_down
 
;Fire Center
    movlw        high A5_A2_reg
    movwf        FSR0H
    movlw        low A5_A2_reg
    movwf        FSR0L

    btfsc        in1,5
    call         p18_led_up
    btfss        in1,5
    call         p18_led_down

;Fire Bottom
    movlw        high A2_A5_reg
    movwf        FSR0H
    movlw        low A2_A5_reg
    movwf        FSR0L

    btfsc        in1,4
    call         p18_led_up
    btfss        in1,4
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Top Back
    movlw        high A5_A0_reg
    movwf        FSR0H
    movlw        low A5_A0_reg
    movwf        FSR0L

    btfsc        in1,3
    call         p18_led_up
    btfss        in1,3
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Top Center
    movlw        high A1_A0_reg
    movwf        FSR0H
    movlw        low A1_A0_reg
    movwf        FSR0L

    btfsc        in1,2
    call         p18_led_up
    btfss        in1,2
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Top Front
    movlw        high A5_A4_reg
    movwf        FSR0H
    movlw        low A5_A4_reg
    movwf        FSR0L

    btfsc        in1,1
    call         p18_led_up
    btfss        in1,1
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Front
    movlw        high A2_A4_reg
    movwf        FSR0H
    movlw        low A2_A4_reg
    movwf        FSR0L

    btfsc        in1,0
    call         p18_led_up
    btfss        in1,0
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Bottom Front
    movlw        high A4_A5_reg
    movwf        FSR0H
    movlw        low A4_A5_reg
    movwf        FSR0L

    btfsc        in2,7
    call         p18_led_up
    btfss        in2,7
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Bottom Center
    movlw        high A5_A1_reg
    movwf        FSR0H
    movlw        low A5_A1_reg
    movwf        FSR0L

    btfsc        in2,6
    call         p18_led_up
    btfss        in2,6
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay

;Running Bottom Center
    movlw        high A2_A1_reg
    movwf        FSR0H
    movlw        low A2_A1_reg
    movwf        FSR0L

    btfsc        in2,5
    call         p18_led_up
    btfss        in2,5
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay


;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t29_exit

    btfsc        IR_in_good,0
    goto         t29_exit

    decfsz       p2count,f
    goto         p29_loop

t29_exit
    return

;**********************************************************************
p18_led_up
;**********************************************************************

    incf        INDF0,f
    btfsc       STATUS,Z
    comf        INDF0,f
    return

;**********************************************************************
p18_led_down
;**********************************************************************

    movf        INDF0,f
    btfss       STATUS,Z
    decf        INDF0,f
    return

