;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
table_type_30
;**********************************************************************
;
;        +++------------------------------ RGB 1
;        |||+++--------------------------- RGB 2
;        ||||||++----+-------------------- RGB 3
;        ||||||||    |+++----------------- RGB 4
;        ||||||||    ||||+++-------------- RGB 5
;        ||||||||    |||||||+    ++------- RGB 6
;        ||||||||    ||||||||    ||++++++- Delay
;        AAABBBCC    CDDDEEEF    FFGGGGGG
;  
;  GGGGGG = delay counter

    call         get_next_pattern_entry
    movwf        in0

    call         get_next_pattern_entry
    movwf        in1

    call         get_next_pattern_entry
    movwf        in2       ; 2 bits LED Data
    movwf        p2count   ; 6 bits loop counter

    LSLF         p2count,f
    LSLF         p2count,f

p18_loop
;   run through the up/down bits.

;1R 0x0f
    movlw        high A2_A1_reg
    movwf        FSR0H
    movlw        low A2_A1_reg
    movwf        FSR0L

    btfsc        in0,7
    call         p18_led_up
    btfss        in0,7
    call         p18_led_down

;2R 0xf0
    movlw        high A0_C2_reg
    movwf        FSR0H
    movlw        low A0_C2_reg
    movwf        FSR0L

    btfsc        in0,4
    call         p18_led_up
    btfss        in0,4
    call         p18_led_down

;3R 0xf0
    movlw        high A1_C1_reg
    movwf        FSR0H
    movlw        low A1_C1_reg
    movwf        FSR0L

    btfsc        in0,1
    call         p18_led_up
    btfss        in0,1
    call         p18_led_down

;4R 0x0f
    movlw        high C2_C0_reg
    movwf        FSR0H
    movlw        low C2_C0_reg
    movwf        FSR0L

    btfsc        in1,6
    call         p18_led_up
    btfss        in1,6
    call         p18_led_down

;5R 0xf0
    movlw        high C1_A2_reg
    movwf        FSR0H
    movlw        low C1_A2_reg
    movwf        FSR0L

    btfsc        in1,3
    call         p18_led_up
    btfss        in1,3
    call         p18_led_down

;6R 0xf0
    movlw        high C0_A0_reg
    movwf        FSR0H
    movlw        low C0_A0_reg
    movwf        FSR0L

    btfsc        in1,0
    call         p18_led_up
    btfss        in1,0
    call         p18_led_down
  
;1G 0xf0
    movlw        high A2_C2_reg
    movwf        FSR0H
    movlw        low A2_C2_reg
    movwf        FSR0L

    btfsc        in0,6
    call         p18_led_up
    btfss        in0,6
    call         p18_led_down


;2G 0xf0
    movlw        high A0_C1_reg
    movwf        FSR0H
    movlw        low A0_C1_reg
    movwf        FSR0L

    btfsc        in0,3
    call         p18_led_up
    btfss        in0,3
    call         p18_led_down


;3G 0xf0
    movlw        high A1_C0_reg
    movwf        FSR0H
    movlw        low A1_C0_reg
    movwf        FSR0L

    btfsc        in0,0
    call         p18_led_up
    btfss        in0,0
    call         p18_led_down
 
;4G 0xf0
    movlw        high C2_A2_reg
    movwf        FSR0H
    movlw        low C2_A2_reg
    movwf        FSR0L

    btfsc        in1,5
    call         p18_led_up
    btfss        in1,5
    call         p18_led_down
 
;5G 0xf0
    movlw        high C1_A0_reg
    movwf        FSR0H
    movlw        low C1_A0_reg
    movwf        FSR0L

    btfsc        in1,2
    call         p18_led_up
    btfss        in1,2
    call         p18_led_down
 
;6G 0xf0
    movlw        high C0_A1_reg
    movwf        FSR0H
    movlw        low C0_A1_reg
    movwf        FSR0L

    btfsc        in2,7
    call         p18_led_up
    btfss        in2,7
    call         p18_led_down


;1B 0xf0
    movlw        high A2_A0_reg
    movwf        FSR0H
    movlw        low A2_A0_reg
    movwf        FSR0L

    btfsc        in0,5
    call         p18_led_up
    btfss        in0,5
    call         p18_led_down


;2B 0x0f
    movlw        high A0_A1_reg
    movwf        FSR0H
    movlw        low A0_A1_reg
    movwf        FSR0L

    btfsc        in0,2
    call         p18_led_up
    btfss        in0,2
    call         p18_led_down
 
;3B 0xf0
    movlw        high A1_C2_reg
    movwf        FSR0H
    movlw        low A1_C2_reg
    movwf        FSR0L

    btfsc        in1,7
    call         p18_led_up
    btfss        in1,7
    call         p18_led_down

;4B 0xf0
    movlw        high C2_C1_reg
    movwf        FSR0H
    movlw        low C2_C1_reg
    movwf        FSR0L

    btfsc        in1,4
    call         p18_led_up
    btfss        in1,4
    call         p18_led_down


;5B 0xf0
    movlw        high C1_C0_reg
    movwf        FSR0H
    movlw        low C1_C0_reg
    movwf        FSR0L

    btfsc        in1,1
    call         p18_led_up
    btfss        in1,1
    call         p18_led_down
 

;6B 0xf0
    movlw        high C0_A2_reg
    movwf        FSR0H
    movlw        low C0_A2_reg
    movwf        FSR0L

    btfsc        in2,6
    call         p18_led_up
    btfss        in2,6
    call         p18_led_down

    movf         pspeed,w
    call         strobe_delay
 
;   This is a quick hack, because without this button presses are not seen for minutes
;   This early exit might impact the pattern getting displayed.
;
    btfsc        button,0    ; if putton pressed show pattern id
    goto         t18_exit

    btfsc        IR_in_good,0
    goto         t18_exit

    decfsz       p2count,f
    goto         p18_loop

t18_exit
    return

;**********************************************************************
p18_led_up
;**********************************************************************

    incf        INDF0,f
    btfsc       STATUS,Z
    comf        INDF0,f
    return

;**********************************************************************
p18_led_down
;**********************************************************************

    movf        INDF0,f
    btfss       STATUS,Z
    decf        INDF0,f
    return

