;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
; DF0 - test pattern
;**********************************************************************
    start_pattern 7, 0x90
     Dt b'01100001' ; right shift /w set 1 time.
     Dt b'00010010' ; right shift /w set 18 times.
    end_pattern

;**********************************************************************
; DF1 - retro
;**********************************************************************
    start_pattern 7, 0x40
     dt b'10100001' ; left shift /w set low time.
     dt b'11000001' ; left shift /w set med time
     dt b'11100001' ; left shift /w set hi time
     dt b'11000001' ; left shift /w set med time
     dt b'10100001' ; left shift /w set low time.
     dt b'10010010' ; left shift /w clear 18 times.
    end_pattern

;**********************************************************************
; DF1 - retro
;**********************************************************************
    start_pattern 7, 0x27
     dt b'01100001' ; right shift /w set hi time
     dt b'00100011' ; right shift /w set low time 3 times
     dt b'00011000' ; right shift /w clear 25 times.
     dt b'11100001' ; left  shift /w set hi time
     dt b'10100011' ; left  shift /w set low time 3 times
     dt b'10011000' ; left  shift /w clear 25 times
    end_pattern

;**********************************************************************
; DF1 - fader
;**********************************************************************
    start_pattern 8, 0x27
    end_pattern

;**********************************************************************
; DF2 - xmas
;**********************************************************************
    start_pattern 7, 0x20
     dt b'11110011' ; left shift /w set 19 times.
     dt b'00011111' ; clear all LEDs
    end_pattern
;**********************************************************************
; DF2 - xmas
;**********************************************************************
    start_pattern 7, 0x20
     dt b'10110011' ; left shift /w low set 19 times.
     dt b'01010011' ; right shift /w med set 19 times.
     dt b'11110011' ; left shift /w hi set 19 times.
     dt b'01010011' ; right shift /w med set 19 times.
     dt b'10110011' ; left shift /w low set 19 times.
     dt b'00011110' ; right shift /w off set 30 times.
    end_pattern
;**********************************************************************
; DF2 - xmas
;**********************************************************************
    start_pattern 7, 0x20
     dt b'00101000' ; right shift /w low set 8 times.
     dt b'01001000' ; right shift /w med set 8 times.
     dt b'01101110' ; right shift /w hi set 30 times.
     dt b'01001000' ; right shift /w med set 8 times.
     dt b'00101000' ; right shift /w low set 8 times.
     dt b'00001000' ; right shift /w off set 8 times.
    end_pattern
;**********************************************************************
; DF3 - train
;**********************************************************************
    start_pattern 7, 0x20
     dt b'11100001' ; left shift /w set 1 time.
     dt b'10010011' ; left shift /w clear 19 times
     dt b'01100001' ; right shift /w set 1 time.
     dt b'00010011' ; right shift /w clear 19 times
    end_pattern

;**********************************************************************
; DF4 - on off
;**********************************************************************
    start_pattern 6, 0x30
    dt 0x55, 0x55, 0x40   ; 1
    dt 0xAA, 0xAA, 0xA0   ; 2
    end_pattern

;**********************************************************************
; DF5 - fast
;**********************************************************************
    start_pattern 7, 0x05
     dt b'11100001' ; left shift /w set 1 time.
     dt b'10010010' ; left shift /w clear 18 times
    end_pattern

;**********************************************************************
; DF6 - center
;**********************************************************************
    start_pattern 6, 0x30
    dt 0x80, 0x00, 0x20   ; L19
    dt 0x40, 0x00, 0x40   ; L18
    dt 0x20, 0x00, 0x80   ; L17
    dt 0x10, 0x01, 0x00   ; L16
    dt 0x08, 0x02, 0x00   ; L15
    dt 0x04, 0x04, 0x00   ; L14
    dt 0x02, 0x08, 0x00   ; L13
    dt 0x01, 0x10, 0x00   ; L12
    dt 0x00, 0xA0, 0x00   ; L11
    dt 0x00, 0x40, 0x00   ; L10
    end_pattern

;**********************************************************************
; DF7 - right
;**********************************************************************
    start_pattern 7, 0x20
      dt b'11100001' ; left shift /w set 1 time.
      dt b'10000011' ; left shift /w clear 3 times
      dt b'11100001' ; left shift /w set 1 time.
      dt b'10010010' ; left shift /w clear 18 times.
    end_pattern

;**********************************************************************
; DF8 - chaser
;**********************************************************************
    start_pattern 6, 0x10
    dt 0x11, 0x11, 0x00   ; L18
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x88, 0x88, 0x80   ; L15
    end_pattern
;**********************************************************************
; DF8 - forward/backward chaser
;**********************************************************************
    start_pattern 6, 0x07
    dt 0x11, 0x11, 0x00   ; L18
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x88, 0x88, 0x80   ; L15
    dt 0x11, 0x11, 0x00   ; L18
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x88, 0x88, 0x80   ; L15
    dt 0x11, 0x11, 0x00   ; L18
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x88, 0x88, 0x80   ; L15
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x11, 0x11, 0x00   ;
    dt 0x88, 0x88, 0x80   ; L15
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x22, 0x22, 0x20   ; L17
    dt 0x11, 0x11, 0x00   ;
    dt 0x88, 0x88, 0x80   ; L15
    dt 0x44, 0x44, 0x40   ; L16
    dt 0x22, 0x22, 0x20   ; L17
    end_pattern
;**********************************************************************
; DF8 - shift
;**********************************************************************
    start_pattern 6, 0x20
    dt 0x2A, 0xAA, 0xA0   ; 1
    dt 0x4A, 0xAA, 0xA0   ; 2
    dt 0x52, 0xAA, 0xA0   ; 3
    dt 0x54, 0xAA, 0xA0   ; 4
    dt 0x55, 0x2A, 0xA0   ; 5
    dt 0x55, 0x4A, 0xA0   ; 6
    dt 0x55, 0x52, 0xA0   ; 7
    dt 0x55, 0x54, 0xA0   ; 8
    dt 0x55, 0x55, 0x20   ; 9
    dt 0x55, 0x55, 0x40   ; 10
    dt 0xA5, 0x55, 0x40   ; 11
    dt 0xA9, 0x55, 0x40   ; 12
    dt 0xAA, 0x55, 0x40   ; 13
    dt 0xAA, 0x95, 0x40   ; 14
    dt 0xAA, 0xA5, 0x40   ; 15
    dt 0xAA, 0xA9, 0x40   ; 16
    dt 0xAA, 0xAA, 0x80   ; 17
    dt 0xAA, 0xAA, 0xA0   ; 18
    end_pattern

;**********************************************************************
; Ward's Bounce
;**********************************************************************


    start_pattern 6, 0x20
    dt  b'10000000',b'00000000',b'00000000'
    dt  b'10000000',b'00000000',b'00000000'
    dt  b'10000000',b'00000000',b'00000000'
    dt  b'01000000',b'00000000',b'00000000'
    dt  b'00010000',b'00000000',b'00000000'
    dt  b'00000010',b'00000000',b'00000000'
    dt  b'00000000',b'01000000',b'00000000'
    dt  b'00000000',b'00001000',b'00000000'
    dt  b'00000000',b'00000001',b'00000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000001',b'00000000'
    dt  b'00000000',b'00001000',b'00000000'
    dt  b'00000000',b'00100000',b'00000000'
    dt  b'00000000',b'01000000',b'00000000'
    dt  b'00000000',b'01000000',b'00000000'
    dt  b'00000000',b'00100000',b'00000000'
    dt  b'00000000',b'00001000',b'00000000'
    dt  b'00000000',b'00000001',b'00000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000010',b'00000000'
    dt  b'00000000',b'00000100',b'00000000'
    dt  b'00000000',b'00000100',b'00000000'
    dt  b'00000000',b'00000010',b'00000000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000001',b'00000000'
    dt  b'00000000',b'00000001',b'00000000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'01000000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000000',b'10000000'
    dt  b'00000000',b'00000000',b'01000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'01000000'
    dt  b'00000000',b'00000000',b'01000000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00100000'
    dt  b'00000000',b'00000000',b'00000001' ;blank
   end_pattern



;**********************************************************************
; eeprom
;**********************************************************************

#ifdef __12F1822
    org 0xF000
#else
    org 0x2100      ; data EEPROM locatio
#endif
        de      0x00      ; demo flag

;**********************************************************************
; Moris Code "Duckon"
;**********************************************************************
    start_pattern 7, 0x70
; M --
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000111' ; left shift /w clear 7 times
; U ..-
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000111' ; left shift /w clear 7 times
; S ...
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000111' ; left shift /w clear 7 times
; E .
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000111' ; left shift /w clear 7 times
; C -.-.
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000111' ; left shift /w clear 7 times
; O ---
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000111' ; left shift /w clear 7 times
; N -.
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000111' ; left shift /w clear 7 times

; '.' .-.-.- 
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000111' ; left shift /w clear 7 times

; C ---
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000111' ; left shift /w clear 7 times
; O .-.
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100001' ; left shift /w set 1 time.        .
      de b'10000111' ; left shift /w clear 7 times
; N --.
      de b'11100011' ; left shift /w set 3 time.        -
      de b'10000011' ; left shift /w clear 3 times
      de b'11100011' ; left shift /w set 3 time.        -

      de b'10010010' ; left shift /w clear 18 times.
    end_pattern


;**********************************************************************
; DF8 - four running
;**********************************************************************
    start_pattern 7, 0x20
      de b'01100100' ; right shift /w set 4 time.
      de b'00010011' ; right shift /w clear 19 times
    end_pattern
;**********************************************************************
; DF8 - down
;**********************************************************************
    start_pattern 7, 0x10
      de b'11110011' ; left shift /w set 19 time.
      de b'10010011' ; left shift /w clear 19 times
    end_pattern
;**********************************************************************
; DF8 - down
;**********************************************************************
    start_pattern 6, 0x10
    de 0x92, 0x49, 0x20   ; Red
    de 0x24, 0x92, 0x40   ; Red
    de 0x49, 0x24, 0x80   ; Red
    end_pattern
;**********************************************************************
; DF8 - down
;**********************************************************************
    start_pattern 6, 0x10
    de 0x92, 0x49, 0x20   ; Red
    de 0x49, 0x24, 0x80   ; Red
    de 0x24, 0x92, 0x40   ; Red
    end_pattern

;**********************************************************************
; DF8 - down
;**********************************************************************
    start_pattern 6, 0x05
    de 0x00, 0x00, 0x20   ; L19
    de 0x00, 0x00, 0x80   ; L17
    de 0x00, 0x02, 0x00   ; L15
    de 0x00, 0x08, 0x00   ; L13
    de 0x00, 0x20, 0x00   ; L11
    de 0x00, 0x80, 0x00   ; L9
    de 0x02, 0x00, 0x00   ; L7
    de 0x08, 0x00, 0x00   ; L5
    de 0x20, 0x00, 0x00   ; L3
    de 0x80, 0x00, 0x00   ; L1
    de 0x00, 0x00, 0x00   ; Blank
    de 0x00, 0x00, 0x40   ; L18
    de 0x00, 0x01, 0x00   ; L16
    de 0x00, 0x04, 0x00   ; L14
    de 0x00, 0x10, 0x00   ; L12
    de 0x00, 0x40, 0x00   ; L10
    de 0x01, 0x00, 0x00   ; L8
    de 0x04, 0x00, 0x00   ; L6
    de 0x10, 0x00, 0x00   ; L4
    de 0x40, 0x00, 0x00   ; L2
    de 0x00, 0x00, 0x00   ; Blank
    end_pattern
;**********************************************************************
; DF8 - round
;**********************************************************************
    start_pattern 6, 0x05
    de 0x00, 0x00, 0x20   ; L19
    de 0x00, 0x00, 0x80   ; L17
    de 0x00, 0x02, 0x00   ; L15
    de 0x00, 0x08, 0x00   ; L13
    de 0x00, 0x20, 0x00   ; L11
    de 0x00, 0x80, 0x00   ; L9
    de 0x02, 0x00, 0x00   ; L7
    de 0x08, 0x00, 0x00   ; L5
    de 0x20, 0x00, 0x00   ; L3
    de 0x80, 0x00, 0x00   ; L1
    de 0x40, 0x00, 0x00   ; L2
    de 0x10, 0x00, 0x00   ; L4
    de 0x04, 0x00, 0x00   ; L6
    de 0x01, 0x00, 0x00   ; L8
    de 0x00, 0x40, 0x00   ; L10
    de 0x00, 0x10, 0x00   ; L12
    de 0x00, 0x04, 0x00   ; L14
    de 0x00, 0x01, 0x00   ; L16
    de 0x00, 0x00, 0x40   ; L18
    end_pattern
;**********************************************************************
; DF1 - retro
;**********************************************************************
    start_pattern 7, 0x10
     de b'11100001' ; left shift /w set 2 time.
     de b'10010010' ; left shift /w clear 18 timesk
    end_pattern

demo_store
    dt 0x00
