;**********************************************************************
;   Copyright (C) 2005,2006,2007,2008 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

    start_pattern 5, 0x60
    Dt 0xFC   ; All
    Dt 0x00   ; Blank

    Dt 0x80   ; G1
    Dt 0x40   ; G2
    Dt 0x20   ; G3
    Dt 0x10   ; G4
    Dt 0x08   ; G5
    Dt 0x05   ; G6
    end_pattern

;**********************************************************************
;table1 ; DF1 - swing
;**********************************************************************

    start_pattern 5, 0x80

    dt 0xB8   ; 1
    dt 0x5C   ; 2
    dt 0xB8   ; 3
    dt 0x74   ; 4
    end_pattern

;**********************************************************************
;  a hacked 4RGB pattern that looks cool on other blinkies. 
;**********************************************************************
  start_pattern 0x0b, 0x30
;            R           c           B
    dt  b'11111100',b'00000000'
    dt  b'11111100',b'00000000'
    dt  b'11111100',b'00000000'
    dt  b'10111101',b'00000000'
    dt  b'01101110',b'01000000' 
    dt  b'00011011',b'10010000'
    dt  b'00000111',b'11100000'
    dt  b'00000011',b'11110000'
    dt  b'00000011',b'11110000'
    dt  b'00000011',b'11110000'
    dt  b'01000011',b'11100000'
    dt  b'10010010',b'10010000'
    dt  b'11100101',b'01000000'
    dt  b'11111000',b'00000000'
    end_pattern

;**********************************************************************
;table2 ; DF2 - xmas
;**********************************************************************
    start_pattern 5, 0x30

    dt 0xA8   ; 1
    dt 0x55   ; 2
    end_pattern

;**********************************************************************
;table3 ; DF3 - retro
;**********************************************************************
    start_pattern 5, 0x30

    dt 0x90   ; 1
    dt 0x24   ; 2
    dt 0x48   ; 3

    end_pattern

;**********************************************************************
; red chase fad up
;**********************************************************************
  start_pattern 0x0b, 0x30
;            R           c           B
    dt  b'01000000',b'00000000' ; low Red
    dt  b'01010000',b'00000000' ; 
    dt  b'01010100',b'00000000' ; 
    dt  b'01010101',b'00000000' ; 
    dt  b'01010101',b'01000000' ; 
    dt  b'01010101',b'01010000' ; 
    dt  b'10010101',b'01010000' ; Med Red
    dt  b'10100101',b'01010000' ; 
    dt  b'10101001',b'01010000' ; 
    dt  b'10101010',b'01010000' ; 
    dt  b'10101010',b'10010000' ; 
    dt  b'10101010',b'10100000' ; 
    dt  b'11101010',b'10100000' ; Hi Red
    dt  b'11111010',b'10100000' ; 
    dt  b'11111110',b'10100000' ; 
    dt  b'11111111',b'10100000' ; 
    dt  b'11111111',b'11100000' ; 
    dt  b'11111111',b'11110000' ; 

    end_pattern

;**********************************************************************
;table4 ; DF4 - down
;**********************************************************************
    start_pattern 5, 0x30

    dt b'10000000'  ; 1
    dt b'01000100'   ; 2
    dt b'00101000'   ; 3
    dt b'00010000'   ; 4
    dt b'00000000'   ; 5
    dt b'00000000'   ; 6
    end_pattern

;**********************************************************************
;table5 ; DF5 - tri
;**********************************************************************
    start_pattern 5, 0x20
 
    dt 0xA8   ; 1
    dt 0x55   ; 2
    end_pattern

;**********************************************************************
;table6 ; DF6 - right/left
;**********************************************************************
    start_pattern 5, 0x30

    dt 0x80   ; 1
    dt 0x40  ; 2
    dt 0x20   ; 3
    dt 0x10   ; 4
    dt 0x08   ; 5
    dt 0x04   ; 6
    dt 0x80   ; 7
    dt 0x04   ; 8
    dt 0x08   ; 9
    dt 0x10   ; 10
    dt 0x20   ; 11
    dt 0x41   ; 12
    end_pattern


;**********************************************************************
;table7 ; DF7 - ?
;**********************************************************************
    start_pattern 5, 0x30
 
    dt 0x80   ; 1
    dt 0xC0   ; 2
    dt 0xE0   ; 3
    dt 0xF0   ; 4
    dt 0xF8   ; 5
    dt 0xFC   ; 6
    dt 0x7C   ; 7
    dt 0x3C   ; 8
    dt 0x1C   ; 9
    dt 0x0C   ; 10
    dt 0x04   ; 11
    dt 0x00   ; 12
    dt 0x01   ; 13
    end_pattern

;**********************************************************************
;table8 ; DF8 - half
;**********************************************************************
    start_pattern 5, 0x30
 
    dt 0xC4   ; 1
    dt 0xE0   ; 2
    dt 0x70   ; 3
    dt 0x38   ; 4
    dt 0x1C   ; 5
    dt 0x8D   ; 6
    end_pattern

;**********************************************************************
;table9 ; DF3 - retro
;**********************************************************************
    start_pattern 5, 0x30

    dt 0x48   ; 1
    dt 0x24   ; 2
    dt 0x91   ; 3
    end_pattern

#ifdef __12F1822
    org 0xF000
#else
    org 0x2100      ; data EEPROM locatio
#endif

;**********************************************************************
;table10 ; DF3 - fast spin
;**********************************************************************

    start_pattern 5, 0x10
    dt 0x80   ; G1
    dt 0x40   ; G2
    dt 0x20   ; G3
    dt 0x10   ; G4
    dt 0x08   ; G5
    dt 0x05   ; G6
    end_pattern

;**********************************************************************
;table11 ; DF3 - hole
;**********************************************************************

    start_pattern 5, 0x10
    dt 0x7C   ; G1
    dt 0xBC   ; G2
    dt 0xDC   ; G3
    dt 0xED   ; G4
    dt 0xF4   ; G5
    dt 0xF9   ; G6
    end_pattern

;**********************************************************************
;table12 ; DF3 - back and for
;**********************************************************************
    start_pattern 5, 0x20
    dt 0x04   ; 1
    dt 0x24   ; 2
    dt 0x80   ; 3
    dt 0x90   ; 4
    dt 0x40   ; 5
    dt 0x48   ; 6
    dt 0x20   ; 7
    dt 0x24   ; 8
    dt 0x10   ; 9
    dt 0x90   ; 10
    dt 0x08   ; 11
    dt 0x49   ; 12
    end_pattern

;**********************************************************************
;table13 ; DF3 - left to right
;**********************************************************************
    start_pattern 5, 0x20
    dt 0x0C   ; 1
    dt 0x90   ; 2
    dt 0x61   ; 3
    end_pattern

;**********************************************************************
;table14 ; DF3 - left to right
;**********************************************************************
    start_pattern 5, 0x30
    dt 0x60   ; 1
    dt 0x90   ; 2
    dt 0x0D   ; 3
    end_pattern

;**********************************************************************
;table15 ; DF3 - hole
;**********************************************************************

    start_pattern 5, 0x30
    dt 0x7C   ; G1
    dt 0xBC   ; G2
    dt 0xDC   ; G3
    dt 0xED   ; G4
    dt 0xF4   ; G5
    dt 0xF9   ; G6
    end_pattern



demo_store
    dt 0x00
