;**********************************************************************
;   Copyright (C) 2005,2006,2007 Dwayne Forsyth
;                                 
;   This program is free software; you can redistribute it and/or
;   modify it under the terms of the GNU General Public License
;   as published by the Free Software Foundation; either version 2
;   of the License, or (at your option) any later version.
; 
;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.
;
;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the
; 
;      Free Software Foundation, Inc.
;      51 Franklin Street, Fifth Floor
;      Boston, MA  02110-1301, USA.
;
;**********************************************************************

;**********************************************************************
; DF1 - test pattern
;**********************************************************************
   start_pattern 6, 0x80

;        +++------------------------------ RGB 1
;        |||+++--------------------------- RGB 2
;        ||||||++----+-------------------- RGB 3
;        ||||||||    |+++----------------- Fire
;        ||||||||    ||||++++----+++------ Running lights
;        ||||||||    ||||||||    |||+----- IR
;        ||||||||    ||||||||    ||||++++- Delay
;        AAABBBCC    CDDDEEEE    EEEFGGGG

   dt  b'11111111',b'11111111',b'11110000' ; all   

   dt  b'10000000',b'00000000',b'00000000' ; 1st RGB Red  
   dt  b'01000000',b'00000000',b'00000000' ; 1st RGB green
   dt  b'00100000',b'00000000',b'00000000' ; 1st RGB Blue

   dt  b'00010000',b'00000000',b'00000000' ; 2nd RGB Red
   dt  b'00001000',b'00000000',b'00000000' ; 2nd RGB green
   dt  b'00000100',b'00000000',b'00000000' ; 2nd RGB blue

   dt  b'00000010',b'00000000',b'00000000' ; 3rd RGB Red
   dt  b'00000001',b'00000000',b'00000000' ; 3rd RGB green
   dt  b'00000000',b'10000000',b'00000000' ; 3rd RGB blue

   dt  b'00000000',b'01000000',b'00000000' ; fire top
   dt  b'00000000',b'00100000',b'00000000' ; fire center
   dt  b'00000000',b'00010000',b'00000000' ; fire bottom
 
   dt  b'00000000',b'00001000',b'00000000' ; top back running
   dt  b'00000000',b'00000100',b'00000000' ; top center running
   dt  b'00000000',b'00000010',b'00000000' ; top front running?

   dt  b'00000000',b'00000001',b'00000000' ; front point

   dt  b'00000000',b'00000000',b'10000000' ; bottom front running
   dt  b'00000000',b'00000000',b'01000000' ; bottom center running
   dt  b'00000000',b'00000000',b'00100000' ; bottom back running

   dt  b'00000000',b'00000000',b'00010000' ; IR?

   end_pattern

;**********************************************************************
; DF2 - up/down
;**********************************************************************
   start_pattern 0x1d, 0x01
;        +++------------------------------ RGB 1
;        |||+++--------------------------- RGB 2
;        ||||||++----+-------------------- RGB 3
;        ||||||||    |+++----------------- Fire
;        ||||||||    ||||++++----+++------ Running lights
;        ||||||||    ||||||||    |||+----- IR
;        ||||||||    ||||||||    ||||++++- Delay
;        AAABBBCC    CDDDEEEE    EEEFGGGG
   dt  b'10010010',b'00000000',b'00000000' ;
   dt  b'01001001',b'00000000',b'00000000' ;
   dt  b'00100100',b'10000000',b'00000000' ;
   dt  b'00000000',b'00000000',b'00000000' ;
   dt  b'00000000',b'01000000',b'00000000' ;
   dt  b'00000000',b'00100000',b'00000000' ;
   dt  b'00000000',b'00010000',b'00000000' ;
   dt  b'00000000',b'00000000',b'00000000' ;
   dt  b'00000000',b'00001000',b'00000000' ;
   dt  b'00000000',b'00000100',b'00000000' ;
   dt  b'00000000',b'00000010',b'00000000' ;
   dt  b'00000000',b'00000001',b'00000000' ;
   dt  b'00000000',b'00000000',b'10000000' ;
   dt  b'00000000',b'00000000',b'01000000' ;
   dt  b'00000000',b'00000000',b'00100000' ;
   dt  b'00000000',b'00000000',b'00000000' ;

   end_pattern

;**********************************************************************
; DF3 - fader test
;**********************************************************************
   start_pattern 0x1d, 0x01
;        +++------------------------------ RGB 1
;        |||+++--------------------------- RGB 2
;        ||||||++----+-------------------- RGB 3
;        ||||||||    |+++----------------- Fire
;        ||||||||    ||||++++----+++------ Running lights
;        ||||||||    ||||||||    |||+----- IR
;        ||||||||    ||||||||    ||||++++- Delay
;        AAABBBCC    CDDDEEEE    EEEFGGGG
   dt  b'10010010',b'01001000',b'00101111' ; 1
   dt  b'10010010',b'01001000',b'00101111' ; 2
   dt  b'10010010',b'00000000',b'00001111' ; 3

   dt  b'01001001',b'00100100',b'01001111' ; 4
   dt  b'01001001',b'00100100',b'01001111' ; 5
   dt  b'01001001',b'00000000',b'00001111' ; 6

   dt  b'00100100',b'10010010',b'10001111' ; 7
   dt  b'00100100',b'10010010',b'10001111' ; 8
   dt  b'00100100',b'10000000',b'00001111' ; 9
   end_pattern

;**********************************************************************
; DF4 - chomp fader
;**********************************************************************
   start_pattern 0x1d, 0x01
   dt  b'10101010',b'10101010',b'10011111' ;tooth 1
   dt  b'01010101',b'01010100',b'01011111' ;tooth 2
   dt  b'10101010',b'10101010',b'00111111' ;tooth 1
   dt  b'01010101',b'01010100',b'10011111' ;tooth 2
   dt  b'10101010',b'10101010',b'01011111' ;tooth 1
   dt  b'01010101',b'01010100',b'00111111' ;tooth 2
   end_pattern

;**********************************************************************
; DF5 - fade down
;**********************************************************************
   start_pattern 0x1d, 0x01
   dt  b'11111111',b'11111111',b'10000001' ; All tooth on
   dt  b'00000000',b'00000000',b'00011111' ; fade off
   dt  b'11111111',b'11111111',b'01000001' ; All tooth on
   dt  b'00000000',b'00000000',b'00011111' ; fade off
   dt  b'11111111',b'11111111',b'00100001' ; All tooth on
   dt  b'00000000',b'00000000',b'00011111' ; fade off
   end_pattern

;**********************************************************************
; DF6 - fade back
;**********************************************************************
   start_pattern 0x1d, 0x01
   dt  b'10000000',b'00001000',b'10001111' ; fade off
   dt  b'11000000',b'00011100',b'11001111' ; fade off
   dt  b'11100000',b'00111110',b'11001111' ; fade off
   dt  b'11110000',b'01111110',b'01001111' ; fade off
   dt  b'11111000',b'11111110',b'01101111' ; fade off
   dt  b'11111101',b'11111110',b'01101111' ; fade off
   dt  b'01111111',b'11110110',b'00101111' ; fade off
   dt  b'00111111',b'11100010',b'10101111' ; fade off
   dt  b'00011111',b'11000000',b'10101111' ; fade off
   dt  b'00001111',b'10000000',b'10001111' ; fade off
   dt  b'00000111',b'00000000',b'11001111' ; fade off
   dt  b'00000010',b'00000000',b'11001111' ; fade off
   dt  b'00000000',b'00000000',b'01001111' ; fade off
   dt  b'00000000',b'00000000',b'01101111' ; fade off
   dt  b'00000000',b'00000000',b'01101111' ; fade off
   end_pattern

;**********************************************************************
; DF7 - Wink & Snapp
;**********************************************************************
   start_pattern 6, 0x07
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'00001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'00000000',b'00000000',b'10001111' ; fade off
   dt  b'11111111',b'11111110',b'10001111' ; fade off
   dt  b'00000000',b'00000000',b'10001111' ; fade off
   end_pattern


;**********************************************************************
; DF8 - chaser 3    
;**********************************************************************
   start_pattern 6, 0x02
   dt  b'10010010',b'01001000',b'01101111' ; fade off
   dt  b'00001000',b'10000000',b'01101111' ; fade off
   dt  b'01000101',b'00010100',b'01101111' ; fade off
   dt  b'00100010',b'00100010',b'01101111' ; fade off
   dt  b'10010000',b'01001000',b'01101111' ; fade off
   dt  b'00001000',b'10000000',b'01101111' ; fade off
   dt  b'01000101',b'00010100',b'01101111' ; fade off
   dt  b'00100010',b'00100010',b'01101111' ; fade off
   end_pattern

;**********************************************************************
; DF9 - chaser 2    
;**********************************************************************
   start_pattern 6, 0x02
   dt  b'10010010',b'01001000',b'00101111' ; fade off
   dt  b'01001000',b'10010100',b'00101111' ; fade off
   dt  b'00100101',b'00100010',b'00101111' ; fade off
   dt  b'10010010',b'01001000',b'00101111' ; fade off
   dt  b'01001000',b'10010100',b'00101111' ; fade off
   dt  b'00100101',b'00100010',b'00101111' ; fade off
   dt  b'10010010',b'01001000',b'00101111' ; fade off
   dt  b'01001000',b'10010100',b'00101111' ; fade off
   dt  b'00100101',b'00100010',b'00101111' ; fade off
   end_pattern


;**********************************************************************
; eeprom
;**********************************************************************

	ORG	0xF000				; data EEPROM location

demo_store
    dt 0x00
