;--------------------------------------------------------------------------------------
display_cycle0  ; A0 R
;--------------------------------------------------------------------------------------
    LedOutInd  A0_A1_reg,Ax_dir,1    ;LED A0-A1 R12
    LedOutInd  A0_A2_reg,Ax_dir,2    ;LED A0-A2 R11
    LedOutInd  A0_C0_reg,Cx_dir,0    ;LED A0-C0 R10
    LedOutInd  A0_C1_reg,Cx_dir,1    ;LED A0-C1 R9
    LedOutInd  A0_C2_reg,Cx_dir,2    ;LED A0-C2 R18
    LedOutInd  A0_C4_reg,Cx_dir,4    ;LED A0-C4 R17

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000001'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle0

    return

;--------------------------------------------------------------------------------------
display_cycle1 ; A1 G
;--------------------------------------------------------------------------------------
    LedOutInd  A1_A0_reg,Ax_dir,0    ;LED A1-A0  G12
;    LedOutInd  A1_A2_reg,Ax_dir,2    ;LED A1-A2  R1
    bsf     Ax_dir,  2
;    LedOutInd  A1_C0_reg,Cx_dir,0    ;LED A1-C0  R2
    bsf     Cx_dir,  0
;    LedOutInd  A1_C1_reg,Cx_dir,1    ;LED A1-C1  R14
    bsf     Cx_dir,  1
;    LedOutInd  A1_C2_reg,Cx_dir,2    ;LED A1-C2  R13
    bsf     Cx_dir,  2
;    LedOutInd  A1_C4_reg,Cx_dir,4    ;LED A1-C4  R19
    bsf     Cx_dir,  4


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000010'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle1

    return

;--------------------------------------------------------------------------------------
display_cycle2 ; A1 R
;--------------------------------------------------------------------------------------
;    LedOutInd  A1_A0_reg,Ax_dir,0    ;LED A1-A0  G12
    bsf     Ax_dir,  0
    LedOutInd  A1_A2_reg,Ax_dir,2    ;LED A1-A2  R1
    LedOutInd  A1_C0_reg,Cx_dir,0    ;LED A1-C0  R2
    LedOutInd  A1_C1_reg,Cx_dir,1    ;LED A1-C1  R14
    LedOutInd  A1_C2_reg,Cx_dir,2    ;LED A1-C2  R13
    LedOutInd  A1_C4_reg,Cx_dir,4    ;LED A1-C4  R19


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000010'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle2

    return

;--------------------------------------------------------------------------------------
display_cycle3 ; R2 G
;--------------------------------------------------------------------------------------
    LedOutInd  A2_A0_reg,Ax_dir,0    ;LED A2-A0 G11 
    LedOutInd  A2_A1_reg,Ax_dir,1    ;LED A2-A1 G1
;    LedOutInd  A2_C0_reg,Cx_dir,0    ;LED A2-C0 R3
    bsf     Cx_dir,  0
;    LedOutInd  A2_C1_reg,Cx_dir,1    ;LED A2-C1 R4
    bsf     Cx_dir,  1
;    LedOutInd  A2_C2_reg,Cx_dir,2    ;LED A2-C2 R15
    bsf     Cx_dir,  2
;    LedOutInd  A2_C4_reg,Cx_dir,4    ;LED A2-C4 R16
    bsf     Cx_dir,  4


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000100'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle3

    return

;--------------------------------------------------------------------------------------
display_cycle4 ; A2 R
;--------------------------------------------------------------------------------------
;    LedOutInd  A2_A0_reg,Ax_dir,0    ;LED A2-A0 G11 
    bsf     Ax_dir,  0
;    LedOutInd  A2_A1_reg,Ax_dir,1    ;LED A2-A1 G1
    bsf     Ax_dir,  1
    LedOutInd  A2_C0_reg,Cx_dir,0    ;LED A2-C0 R3
    LedOutInd  A2_C1_reg,Cx_dir,1    ;LED A2-C1 R4
    LedOutInd  A2_C2_reg,Cx_dir,2    ;LED A2-C2 R15
    LedOutInd  A2_C4_reg,Cx_dir,4    ;LED A2-C4 R16


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000100'
    movwf   PORTA
    movlw   b'00000000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle4

    return

;--------------------------------------------------------------------------------------
display_cycle5 ; C0 G
;--------------------------------------------------------------------------------------

    LedOutInd  C0_A0_reg,Ax_dir,0    ;LED C0-A0 G10
    LedOutInd  C0_A1_reg,Ax_dir,1    ;LED C0-A1 G2
    LedOutInd  C0_A2_reg,Ax_dir,2    ;LED C0-A2 G3
;    LedOutInd  C0_C1_reg,Cx_dir,1    ;LED C0-C1 R5
    bsf     Cx_dir,  1
;    LedOutInd  C0_C2_reg,Cx_dir,2    ;LED C0-C2 R6
    bsf     Cx_dir,  2
;    LedOutInd  C0_C4_reg,Cx_dir,4    ;LED C0-C4 R7
    bsf     Cx_dir,  4


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00000001'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle5

    return
;--------------------------------------------------------------------------------------
display_cycle6 ; C0 R
;--------------------------------------------------------------------------------------

;    LedOutInd  C0_A0_reg,Ax_dir,0    ;LED C0-A0 G10
    bsf     Ax_dir,  0
;    LedOutInd  C0_A1_reg,Ax_dir,1    ;LED C0-A1 G2
    bsf     Ax_dir,  1
;    LedOutInd  C0_A2_reg,Ax_dir,2    ;LED C0-A2 G3
    bsf     Ax_dir,  2
    LedOutInd  C0_C1_reg,Cx_dir,1    ;LED C0-C1 R5
    LedOutInd  C0_C2_reg,Cx_dir,2    ;LED C0-C2 R6
    LedOutInd  C0_C4_reg,Cx_dir,4    ;LED C0-C4 R7


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00000001'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle6

    return

;--------------------------------------------------------------------------------------
display_cycle7 ; C1 G
;--------------------------------------------------------------------------------------


    LedOutInd  C1_A0_reg,Ax_dir,0    ;LED C1-A0 G9
    LedOutInd  C1_A1_reg,Ax_dir,1    ;LED C1-A1 G14
    LedOutInd  C1_A2_reg,Ax_dir,2    ;LED C1-A2 G4
    LedOutInd  C1_C0_reg,Cx_dir,0    ;LED C1-C0 G5
;    LedOutInd  C1_C2_reg,Cx_dir,2    ;LED C1-C2
    bsf     Cx_dir,  2
;    LedOutInd  C1_C4_reg,Cx_dir,4    ;LED C1-C4 R8
    bsf     Cx_dir,  4


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00000010'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle7
;--------------------------------------------------------------------------------------
display_cycle8 ; C1 R
;--------------------------------------------------------------------------------------


;    LedOutInd  C1_A0_reg,Ax_dir,0    ;LED C1-A0 G9
    bsf     Ax_dir,  0
;    LedOutInd  C1_A1_reg,Ax_dir,1    ;LED C1-A1 G14
    bsf     Ax_dir,  1
;    LedOutInd  C1_A2_reg,Ax_dir,2    ;LED C1-A2 G4
    bsf     Ax_dir,  2
;    LedOutInd  C1_C0_reg,Cx_dir,0    ;LED C1-C0 G5
    bsf     Cx_dir,  0
;    LedOutInd  C1_C2_reg,Cx_dir,2    ;LED C1-C2
    bsf     Cx_dir,  2
    LedOutInd  C1_C4_reg,Cx_dir,4    ;LED C1-C4 R8



    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00000010'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle8

    return


;--------------------------------------------------------------------------------------
display_cycle9 ; C2 G
;--------------------------------------------------------------------------------------

    LedOutInd  C2_A0_reg,Ax_dir,0    ;LED C2-A0  G18
    LedOutInd  C2_A1_reg,Ax_dir,1    ;LED C2-A1  G13
    LedOutInd  C2_A2_reg,Ax_dir,2    ;LED C2-A2  G15
    LedOutInd  C2_C0_reg,Cx_dir,0    ;LED C2-C0  G6
;    LedOutInd  C2_C1_reg,Cx_dir,1    ;LED C2-C1
    bsf     Cx_dir,  1
;    LedOutInd  C2_C4_reg,Cx_dir,4    ;LED C2-C4
    bsf     Cx_dir,  4

    

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00000100'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle9

    return

;--------------------------------------------------------------------------------------
display_cycle10 ; C4 G
;--------------------------------------------------------------------------------------

    LedOutInd  C4_A0_reg,Ax_dir,0    ;LED C4-A0 G17 
    LedOutInd  C4_A1_reg,Ax_dir,1    ;LED C4-A1 G19
    LedOutInd  C4_A2_reg,Ax_dir,2    ;LED C4-A2 G16
    LedOutInd  C4_C0_reg,Cx_dir,0    ;LED C4-C0 G7
    LedOutInd  C4_C1_reg,Cx_dir,1    ;LED C4-C1 G8
;    LedOutInd  C4_C2_reg,Cx_dir,2    ;LED C4-C2
    bsf     Cx_dir,  2


    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    movf    Cx_dir,w      ;set portA direction
    movwf   TRISC

    banksel PORTA
    movlw   b'00000000'
    movwf   PORTA

    movlw   b'00010000'
    movwf   PORTC

    decfsz  fcount,f
    goto    display_cycle10
    clrf    PORTC

    return

