;--------------------------------------------------------------------------------------
display_cycle0
;--------------------------------------------------------------------------------------
#ifdef Common_Cathode
    LedOut  Dr_reg,Ax_dir,1    ;LED Dr     A0-A1
    LedOut  Dg_reg,Ax_dir,2    ;LED Dg     A0-A2
    LedOut  Db_reg,Ax_dir,5    ;LED Db     A0-A5
#else
    LedOut  Ab_reg,Ax_dir,1    ;LED Ab     A0-A1
    LedOut  Bg_reg,Ax_dir,2    ;LED Bg     A0-A2
    LedOut  Cr_reg,Ax_dir,5    ;LED Cr     A0-A5
#endif

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA

    banksel PORTA
    movlw   b'00000001'
    movwf   PORTA

    decfsz  fcount,f
    goto    display_cycle0

    return

;--------------------------------------------------------------------------------------
display_cycle1
;--------------------------------------------------------------------------------------
#ifdef Common_Cathode
    LedOut  Ab_reg,Ax_dir,0    ;LED Ab     A1-A0
    LedOut  Ar_reg,Ax_dir,2    ;LED Ar     A1-A2
    LedOut  Ag_reg,Ax_dir,5    ;LED Ag     A1-A5
#else
    LedOut  Dr_reg,Ax_dir,0    ;LED Dr     A1-A0
    LedOut  Bb_reg,Ax_dir,2    ;LED Bb     A1-A2
    LedOut  Cg_reg,Ax_dir,5    ;LED Cg     A1-A5
#endif

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA
    
    banksel PORTA
    movlw   b'00000010'
    movwf   PORTA

    decfsz  fcount,f
    goto    display_cycle1

    return

;--------------------------------------------------------------------------------------
display_cycle2
;--------------------------------------------------------------------------------------
#ifdef Common_Cathode
    LedOut  Bg_reg,Ax_dir,0    ;LED Bg     A2-A0
    LedOut  Bb_reg,Ax_dir,1    ;LED Bb     A2-A1
    LedOut  Br_reg,Ax_dir,5    ;LED Br     A2-A5
#else
    LedOut  Dg_reg,Ax_dir,0    ;LED Dg     A2-A0
    LedOut  Ar_reg,Ax_dir,1    ;LED Ar     A2-A1
    LedOut  Cb_reg,Ax_dir,5    ;LED Cb     A2-A5
#endif

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA

    banksel PORTA
    movlw   b'00000100'
    movwf   PORTA

    decfsz  fcount,f
    goto    display_cycle2

    return

;--------------------------------------------------------------------------------------
display_cycle3
;--------------------------------------------------------------------------------------
#ifdef Common_Cathode
    LedOut  Cr_reg,Ax_dir,0    ;LED Cr     A5-A0
    LedOut  Cg_reg,Ax_dir,1    ;LED Cg     A5-A1
    LedOut  Cb_reg,Ax_dir,2    ;LED Cb     A5-A2
#else
    LedOut  Db_reg,Ax_dir,0    ;LED Db     A5-A0
    LedOut  Ag_reg,Ax_dir,1    ;LED Ag     A5-A1
    LedOut  Br_reg,Ax_dir,2    ;LED Br     A5-A2
#endif

    banksel TRISA
    movf    Ax_dir,w      ;set portA direction
    movwf   TRISA

    banksel PORTA
    movlw   b'00100000'
    movwf   PORTA

    decfsz  fcount,f
    goto    display_cycle3

    return

